      character file*40, window*8, windowrr*8, stime*19, dbase*3
      integer instr1, instr2, nchan2, nchan1, npt
      integer m, kspecy, kspecz, i, azimuth, nest
      integer getnarg, narg, if, n
      character*4 casver
      character*2 cprint
      character*1 ans, incr, sep, hash
      real samp, alpha
      real y(49), z(49), period(20), delta
      real lat1, long1, elev1, lat2, long2, elev2
      real ochd, ocnh, ocnd, oceh, oced, mcnhd, mcehd,
     &     pcnhd, pcndh, pcehd, pcedh, mczhd, focoh, fmcoh,
     &     rxx, rxy, ryx, ryy, rtx, rty
      complex s7(7,7), zxx, zxy, zyx, zyy, tzx, tzy

      character*6 progprec, dataprec
      logical SINGLE

      common /confl/ alpha

      include 'version.inc' 
      include 'bdate.inc' 
c     --- modified for version 4 --- JAC Nov 19 1996
      include 'maxflims.inc'
      include 'ctrlblk.inc' 

      alpha = 0.32               ! derives 68% confidence interval
c      alpha = 0.05               ! derives 95% confidence interval



      call precision( SINGLE )
      if( SINGLE ) then
        progprec = 'SINGLE'
      else
        progprec = 'DOUBLE'
      endif


      narg = getnarg()
      if( narg.ge.1 ) then
        call getcmdarg( 1, cprint) 
        read(cprint,'(i2)') iprint
      else
        iprint = 0
      end if
      call iin( 'Give print level (-1/0/1/2/3)',iprint)

      if( iprint.ge.1 ) then
        write(*,*)' '
        write(*,*)' >>>>>>>>>>>>> CAS2TAB <<<<<<<<<<<<<<<<<<<'
        write(*,*)' '
        write(*,*)'           version = ', ver
        write(*,*)'build date = ', bdate
        write(*,*)' '
        write(*,*)'It is assumed that this program is being run from'
        write(*,*)'the database directory of the project '
        write(*,*)'(e.g. /local/mt/lims/nod)  '
        write(*,*)'and that all data files reside in subdirectories'
        write(*,*)'with the respective station names '
        write(*,*)'(e.g. /local/mt/lims/nod/nod001 nod002 etc.)'
        write(*,*)' '
        write(*,*)'windows and hardware database files are required'
        write(*,*)'(e.g. windows.nod & hardware.nod) '
        write(*,*)' '
      end if

      dbase = 'tho'
      call tin( 'Give database namename', dbase )

      file = '.cas'
10    call tin( 'Give cascade filename', file )
      if( index(file,'.cas').eq.0 ) then
        file = dbase//file(1:3)//'/'//file(1:8)//'.cas'
      else
        file = dbase//file(1:3)//'/'//file
      endif
      open(unit=4,file=file,form='UNFORMATTED',status='old',err=20)
      goto 30

20    write(*,*)'Error opening file with name >',file
      goto 10

30    ans = 'y'
      call yin( 'Do you want increment written into file?', ans )
      incr = ans

      ans = 'y'
      call yin( 'Do you want separate files for real & imag?', ans )
      sep = ans

c      ans = 'y'
c      call yin( 'Reject bad estimates?', ans )
c      if( ans.eq.'y' ) then
c        REJECT = .TRUE.
c      else
c        REJECT = .FALSE.
c      endif

      if( incr.eq.'y' .and. sep.eq.'y' ) then
        open(unit=11,file='zxxr.tab')
        open(unit=12,file='zxyr.tab')
        open(unit=13,file='zyxr.tab')
        open(unit=14,file='zyyr.tab')
        open(unit=15,file='tzxr.tab')
        open(unit=16,file='tzyr.tab')
        open(unit=21,file='zxxi.tab')
        open(unit=22,file='zxyi.tab')
        open(unit=23,file='zyxi.tab')
        open(unit=24,file='zyyi.tab')
        open(unit=25,file='tzxi.tab')
        open(unit=26,file='tzyi.tab')
      else
        open(unit=11,file='zxx.tab')
        open(unit=12,file='zxy.tab')
        open(unit=13,file='zyx.tab')
        open(unit=14,file='zyy.tab')
        open(unit=15,file='tzx.tab')
        open(unit=16,file='tzy.tab')
      endif
      open(unit=27,file='hx.tab')
      open(unit=28,file='hy.tab')
      open(unit=29,file='hz.tab')
      open(unit=30,file='ex.tab')
      open(unit=31,file='ey.tab')
      open(unit=32,file='exhy_coh.tab')
      open(unit=33,file='eyhx_coh.tab')

c...read over comment information in cascade file
      read(4) hash
      do while( hash.eq.'#' )
        read(4) hash
      enddo
      backspace(4)

c...read in header information
      read(4) casver
      read(4) dataprec

      write(*,'(2a)')'Cascade version =', casver
      write(*,'(a)') dataprec//' precision cascade file'

      if( casver.ne.ver ) then
        write(*,*)'Cascade file with different version'
        write(*,*)'Program version =',ver,'   Cascade file =',casver
        write(*,*)'Re-run tscascade'
        stop
      endif

      if( progprec.ne.dataprec ) then
        write(*,*)'Cascade file with different precision'
        write(*,*)'Program version ='//progprec//'   Cascade file ='//
     &            dataprec
        stop
      endif

      read(4) window,   instr1, nchan1, lat1, long1, elev1
      read(4) windowrr, instr2, nchan2, lat2, long2, elev2
      read(4) stime, samp, npt, azimuth

      write(*,'(5a,2i3,a,2i2)')'window=', window,'  remote=',
     &           windowrr,' instruments = ', instr1, instr2,
     &           ' channels=', nchan1, nchan2
      write(*,'(a,i5.3,a,f)') 'azimuth=',azimuth,'   samp=',samp

      delta = 1.0/samp
      do i = 1, MAXF2
        period(2*i-1) = (32.*delta*(2.**(I-1)))/8.
        period(2*i)   = (32.*delta*(2.**(I-1)))/6.
      enddo

      if( samp.gt.1. ) then
        write(*,*)'Frequencies ==>'
        write(*,'(7(i2,'':'',i6,2x))' ) (i,ifix(1./period(i)),i=1,MAXF)
      else
        write(*,*)'Periods ==>'
        write(*,'(7(i2,'':'',i6,2x))' ) (i,ifix(period(i)),i=1,MAXF)
      endif

      if = 1
      call iin( 'Give frequency no. to write estimates out for', if )

      nest = 0

   11 read(4,end=50) m, kspecy, (y(i),i=1,49),
     &                  kspecz, (z(i),i=1,49)

      if( iprint.ge.2 ) then
        write(*,*)'m, kspecy, kspecz = ', m, kspecy, kspecz
      endif

      if( 2*m-1 .eq. if ) then
        if( kspecz.eq.0 )goto 11
        call acspec7( z, s7 )
        n = kspecz
      else if( 2*m .eq. if ) then
        if( kspecy.eq.0 )goto 11
        call acspec7( y, s7 )
        n = kspecy
      else
        goto 11
      endif

      nest = nest + 1

c---ocoh(hx,hy)
      ochd = focoh( 7, s7, 1, 2 )
c---ocoh(ex,hx)
      ocnh = focoh( 7, s7, 3, 1 )
c---ocoh(ex,hy)
      ocnd = focoh( 7, s7, 3, 2 )
c---ocoh(ey,hx)
      oceh = focoh( 7, s7, 4, 1 )
c---ocoh(ey,hy)
      oced = focoh( 7, s7, 4, 2 )
c---mcoh(ex,hx,hy)
      mcnhd = fmcoh( 7, s7, 3, 1, 2 )
c---mcoh(ey,hx,hy)
      mcehd = fmcoh( 7, s7, 4, 1, 2 )
c---mcoh(hz,hx,hy)
      mczhd = fmcoh( 7, s7, 5, 1, 2 )
c---pcoh(ex,hx, hy)
      pcnhd = ( mcnhd - ocnd ) / ( 1. - ocnd )
c---pcoh(ex,hy, hx)
      pcndh = ( mcnhd - ocnh ) / ( 1. - ocnh )
c---pcoh(ey,hx, hy)
      pcehd = ( mcehd - oced ) / ( 1. - oced )
c---pcoh(ey,hy, hx)
      pcedh = ( mcehd - oceh ) / ( 1. - oceh )

      if(  ochd.le.0. .or.  ochd.gt.1. ) then
        write(*,*)'ochd inadmissable: nest=', nest, ochd
        nest = nest - 1
        goto 11
      endif
      if(  ocnh.le.0. .or.  ocnh.gt.1. ) then
        write(*,*)'ocnh inadmissable: nest=', nest, ocnh
        nest = nest - 1
        goto 11
      endif
      if(  ocnd.le.0. .or.  ocnd.gt.1. ) then
        write(*,*)'ocnd inadmissable: nest=', nest, ocnd
        nest = nest - 1
        goto 11
      endif
      if(  oceh.le.0. .or.  oceh.gt.1. ) then
        write(*,*)'oceh inadmissable: nest=', nest, oceh
        nest = nest - 1
        goto 11
      endif
      if(  oced.le.0. .or.  oced.gt.1. ) then
        write(*,*)'oced inadmissable: nest=', nest, oceh
        nest = nest - 1
        goto 11
      endif
      if( mcnhd.le.0. .or. mcnhd.gt.1. ) then
        write(*,*)'mcnhd inadmissable: nest=', nest, mcnhd
        nest = nest - 1
        goto 11
      endif
      if( mcehd.le.0. .or. mcehd.gt.1. ) then
        write(*,*)'mcehd inadmissable: nest=', nest, mcehd
        nest = nest - 1
        goto 11
      endif
      if( pcnhd.le.0. .or. pcnhd.gt.1. ) then
        write(*,*)'pcnhd inadmissable: nest=', nest, pcnhd
        nest = nest - 1
        goto 11
      endif
      if( pcndh.le.0. .or. pcndh.gt.1. ) then
        write(*,*)'pcndh inadmissable: nest=', nest, pcndh
        nest = nest - 1
        goto 11
      endif
      if( pcehd.le.0. .or. pcehd.gt.1. ) then
        write(*,*)'pcehd inadmissable: nest=', nest, pcehd
        nest = nest - 1
        goto 11
      endif
      if( pcedh.le.0. .or. pcedh.gt.1. ) then
        write(*,*)'pcedh inadmissable: nest=', nest, pcedh
        nest = nest - 1
        goto 11
      endif

c      if( mczhd.le.0. .or. mczhd.gt.1. ) then
c        write(*,*)'mczhd inadmissable: nest=', nest, mczhd
c        nest = nest - 1
c        goto 11
c      endif

      call trfn( 7, s7, 1, 2, 6, 7, 3, zxx, zxy )
      call trfn( 7, s7, 1, 2, 6, 7, 4, zyx, zyy )
      call trfn( 7, s7, 1, 2, 6, 7, 5, tzx, tzy )

      call rccf2( 2*n, mcnhd, ochd, real(s7(3,3)), real(s7(1,1)), rxx)
      call rccf2( 2*n, mcnhd, ochd, real(s7(3,3)), real(s7(2,2)), rxy)
      call rccf2( 2*n, mcehd, ochd, real(s7(4,4)), real(s7(1,1)), ryx)
      call rccf2( 2*n, mcehd, ochd, real(s7(4,4)), real(s7(2,2)), ryy)
      call rccf2( 2*n, mczhd, ochd, real(s7(5,5)), real(s7(1,1)), rtx)
      call rccf2( 2*n, mczhd, ochd, real(s7(5,5)), real(s7(2,2)), rty)

      if( iprint.ge.1 ) then
        write(*,*)'Estimates ==>'
        write(*,*) zxx, zxy
        write(*,*) zyx, zyy
      endif

      if( incr.eq.'y' ) then
        if( sep.eq.'y' ) then
          write(11,*)  nest, real(zxx), rxx
          write(12,*)  nest, real(zxy), rxy
          write(13,*)  nest, real(zyx), ryx
          write(14,*)  nest, real(zyy), ryy
          write(15,*)  nest, real(tzx), rtx
          write(16,*)  nest, real(tzy), rty
          write(21,*)  nest, aimag(zxx), rxx
          write(22,*)  nest, aimag(zxy), rxy
          write(23,*)  nest, aimag(zyx), ryx
          write(24,*)  nest, aimag(zyy), ryy
          write(25,*)  nest, aimag(tzx), rtx
          write(26,*)  nest, aimag(tzy), rty
        else
          write(11,*)  nest, real(zxx), aimag(zxx), rxx
          write(12,*)  nest, real(zxy), aimag(zxy), rxy
          write(13,*)  nest, real(zyx), aimag(zyx), ryx
          write(14,*)  nest, real(zyy), aimag(zyy), ryy
          write(15,*)  nest, real(tzx), aimag(tzx), rtx
          write(16,*)  nest, real(tzy), aimag(tzy), rty
        endif
        write(27,*)  nest, real(s7(1,1))
        write(28,*)  nest, real(s7(2,2))
        write(29,*)  nest, real(s7(5,5))
        write(30,*)  nest, real(s7(3,3))
        write(31,*)  nest, real(s7(4,4))
        write(32,*)  nest ,ocnd
        write(33,*)  nest, oceh
      else
        write(11,*)  real(zxx), aimag(zxx), rxx
        write(12,*)  real(zxy), aimag(zxy), rxy
        write(13,*)  real(zyx), aimag(zyx), ryx
        write(14,*)  real(zyy), aimag(zyy), ryy
        write(15,*)  real(tzx), aimag(tzx), rtx
        write(16,*)  real(tzy), aimag(tzy), rty
        write(27,*)  real(s7(1,1))
        write(28,*)  real(s7(2,2))
        write(29,*)  real(s7(5,5))
        write(30,*)  real(s7(3,3))
        write(31,*)  real(s7(4,4))
        write(32,*)  ocnd
        write(33,*)  oceh
      endif

      goto 11

   50 write(*,*) nest,'  estimates written to files'
      if( iprint.ge.1 ) then
      if( sep.eq.'y' ) then
        write(*,*)'tzxr.tab Real GDS transfer function between Hz & Hx'
        write(*,*)'tzxi	   Imag GDS transfer function between Hz & Hx'
        write(*,*)'tzyr.tab Real GDS transfer function between Hz & Hy'
        write(*,*)'tzyi.tab Imag GDS transfer function between Hz & Hy'
        write(*,*)'zxxr.tab Real MT  transfer function between Ex & Hx'
        write(*,*)'zxxi.tab Real MT  transfer function between Ex & Hx'
        write(*,*)'zxyr.tab Real MT  transfer function between Ex & Hy'
        write(*,*)'zxyi.tab Imag MT  transfer function between Ex & Hy'
        write(*,*)'zyxr.tab Real MT  transfer function between Ey & Hx'
        write(*,*)'zyxi.tab Imag MT  transfer function between Ey & Hx'
        write(*,*)'zyyr.tab Real MT  transfer function between Ey & Hy'
        write(*,*)'zyyi.tab Imag MT  transfer function between Ey & Hy'
      else
        write(*,*)'tzx.tab cmplx GDS transfer function between Hz & Hx'
        write(*,*)'tzy.tab cmplx GDS transfer function between Hz & Hy'
        write(*,*)'zxx.tab cmplx MT  transfer function between Ex & Hx'
        write(*,*)'zxy.tab cmplx MT  transfer function between Ex & Hy'
        write(*,*)'zyx.tab cmplx MT  transfer function between Ey & Hx'
        write(*,*)'zyy.tab cmplx MT  transfer function between Ey & Hy'
      endif
      write(*,*)'ex.tab  amplitude in Ex component'
      write(*,*)'ey.tab  amplitude in Ey component'
      write(*,*)'hx.tab  amplitude in Hx component'
      write(*,*)'hy.tab  amplitude in Hy component'
      write(*,*)'hz.tab  amplitude in Hz component'
      write(*,*)'exhy_coh.tab  partial coherence between Ex & Hy'
      write(*,*)'eyhx_coh.tab  partial coherence between Ey & Hx'
      endif

      stop 'Done.'
      end

