
      include 'fgraph.fi'
c--------------------------------------------------------------------------
      subroutine graphics_mode()
c--------------------------------------------------------------------------
      include   'fgraph.fd'
      integer*2 dummy, maxx, maxy
      real*4    xmax, ymax
      record /videoconfig/ myscreen
      common /screensize/  maxx, maxy, xmax, ymax
c
c Select the `best' video mode - ie highest resolution then max colors.
c
      call getvideoconfig( myscreen )
      select case( myscreen.adapter )
        case( $cga )
         dummy = setvideomode( $HRESBW )
        case( $ocga )
         dummy = setvideomode( $ORESCOLOR )
        case( $ega, $oega )
         if( myscreen.monitor .eq. $mono ) then
           dummy = setvideomode( $ERESNOCOLOR )
          else
           dummy = setvideomode( $ERESCOLOR )
         end if
        case( $mcga )
         dummy = setvideomode( $VRES2COLOR )
        case( $vga, $ovga )
         dummy = setvideomode( $VRES16COLOR )
        case( $hgc )
         dummy = setvideomode( $HERCMONO )
        case default
         dummy = 0
      end select
      if(dummy.eq.0) stop 'Error: cannot set graphics mode'
      call getvideoconfig( myscreen )
      maxx = myscreen.numxpixels - 1
      maxy = myscreen.numypixels - 1
c
c Select vector style fonts - pixel fonts don't work as well for this
c package and I wouldn't recommend then
c
      dummy = registerfonts( 'modern.fon' )
      call clearscreen( $gclearscreen )
      return
      end
c------------------------------------------------------------------------
      integer*2 function newx( xcoord )
c------------------------------------------------------------------------
c These routines convert (x,y) positions to screen pixel location.
c
      integer*2 maxx, maxy
      real*4    tempx, xcoord, xmax, ymax
      common /screensize/ maxx, maxy, xmax, ymax
c
      tempx = float( maxx ) * xcoord / xmax + 0.5
      newx  = nint( tempx )
      return
      end
c------------------------------------------------------------------------
      integer*2 function newy( ycoord ) 
c------------------------------------------------------------------------
      integer*2 maxx, maxy
      real*4    tempy, ycoord, xmax, ymax
      common /screensize/ maxx, maxy, xmax, ymax
c
      tempy = float( maxy ) * (1.0 - ycoord / ymax) - 0.5
      newy  = nint( tempy )
      return
      end
c------------------------------------------------------------------------
      integer*2 function newh( ycoord ) 
c------------------------------------------------------------------------
      integer*2 maxx, maxy
      real*4    tempy, ycoord, xmax, ymax
      common /screensize/ maxx, maxy, xmax, ymax
c
      tempy = float( maxy ) * ycoord / ymax - 0.5
      newh  = nint( tempy )
      return
      end
c------------------------------------------------------------------------
      integer*2 function neww( xcoord ) 
c------------------------------------------------------------------------
      integer*2 maxx, maxy
      real*4    tempx, xcoord, xmax, ymax
      common /screensize/ maxx, maxy, xmax, ymax
c
      tempx = float( maxx ) * xcoord / xmax - 0.5
      neww  = nint( tempx )
      return
      end
c---------------------------------------------------------------------------
      integer*4 function rgb(r, g, b)
c---------------------------------------------------------------------------
      integer*4 r, g, b
c
      rgb = ishl( ishl( b, 8) .or. g, 8) .or. r
      return
      end

c-------------------------------------------------------------------
      subroutine advplt
c-------------------------------------------------------------------
      write(*,*)'buplot:ADVPLT not supported.'
      return
      end 
c-------------------------------------------------------------------
      subroutine flsh12
c-------------------------------------------------------------------

      return
      end 
c-------------------------------------------------------------------
      subroutine hldplt
c-------------------------------------------------------------------
      write(*,*)'buplot:HLDPLT not supported.'
      return
      end 
c-------------------------------------------------------------------
      subroutine hldset
c-------------------------------------------------------------------
      write(*,*)'buplot:HLSDET not supported.'
      return
      end 
c-------------------------------------------------------------------
      subroutine pclrdf
c-------------------------------------------------------------------
      write(*,*)'buplot:PCLRDF not supported.'
      return
      end 
c-------------------------------------------------------------------------
      subroutine factor( fact )
c-------------------------------------------------------------------------
      real            xorg, yorg, scal, fact
      common /origin/ xorg, yorg, scal
c
      scal = fact*scal
      return
      end
c-------------------------------------------------------------------------
      subroutine ctype( itype )
c-------------------------------------------------------------------------
      integer itype
      write(*,*)'buplot: CTYPE not supported.'
      return
      end
c-------------------------------------------------------------------
      subroutine endplt
c-------------------------------------------------------------------

      include   'fgraph.fd'
      record /rccoord/ curpos

      real      lastx, lasty, psscale
      integer*4 lout, iold, icount
      common /output/ lout, iold, lastx, lasty, psscale, icount

      call flsh12

c
      call settextposition(1,1,curpos)
      call pcolor( 1 )
      call outtext('Press <RET> to continue')
      read(*,*)
c
c Reset the video mode
c
      dummy = setvideomode( $defaultmode )
      call unregisterfonts()

c
      if(lout.eq.0) return
c
c Close the postscript file
c
      write(lout,1) 
1     format('showpage')
      close(unit=lout)

      return
      end 
c-------------------------------------------------------------------
      subroutine opnplt(terminal)
c-------------------------------------------------------------------
      character terminal*(*)
      real      xsizmm, ysizmm, xorg, yorg, scal, lastx, lasty
      real      psscale
      integer   lout, iold, icount
c

      integer*2 maxx, maxy
      real      xmax, ymax
      common /screensize/ maxx, maxy, xmax, ymax

      common /output/ lout, iold, lastx, lasty, psscale, icount
      common /origin/ xorg, yorg, scal

      integer narg, iarg, getnarg
      character*80 arg
      
c
c Origin is at the lower left corner of the screen
c
      xorg = 0.0
      yorg = 0.0
c

      call graphics_mode()
      xmax = 250.
      ymax = 250.


      scal = 1.0
      call pcolor( 1 )

      lout = 0
      narg = getnarg()
      do iarg = 1, narg
        call getcmdarg(iarg,arg)
        if(arg.eq.' ') then
            write(*,*)' buplot: error getting command line args.'
            stop
        elseif( index(arg,'ps ').gt.0 ) then
           lout = 1
        endif
      end do  
      if(lout.eq.0) return

c Set up output for ascii postscript file
c
      iold = 0
c
c Set up postscript style output
c
      open(unit=lout,file='buplot.ps',status='unknown')
      write(lout,1) 
1     format('%!',/,
     >       '%%Creator: buplot FORTRAN plotting package',/,
     >       '%%Pages: 1',/,
     >       '%%EndComments',//,
     >       '/l {lineto} def /m {moveto} def ',
     >       '/srgb {setrgbcolor} def',/,'/font {/Helvetica} def ',
     >       '/s {stroke} def /n {newpath} def',//,'%%EndProlog',/)
      write(lout,2)
2     format('550 40 translate 90 rotate ')
      psscale = 72.0 / 25.4
      icount = 1
c
      return
      end
c------------------------------------------------------------------
      subroutine scale( fact )
c------------------------------------------------------------------
      real            xorg, yorg, scal, fact
      common /origin/ xorg, yorg, scal
c
      scal = fact
      return
      end
c------------------------------------------------------------------
      subroutine pcolor( icol )
c------------------------------------------------------------------

      include   'fgraph.fd'
      integer*2 dummy, cicol
      integer dummy4, rgb

      integer icol, i, red(16), grn(16), blu(16)
      real    cwid
      integer*4 icount, iold, lout
      real      lastx, lasty, psscale
      common /output/ lout, iold, lastx, lasty, psscale, icount
      common /pens/ cwid, cicol
c
      DATA red /  0, 63, 63, 21,  0, 63, 10, 21,
     >            0,  0, 63, 25, 25,  0, 32, 63/
      DATA grn /  0, 63,  0,  0, 21, 10, 63, 47,
     >           63, 38,  0, 38, 25, 63,  0, 63/
      DATA blu /  0, 63, 63, 63, 63,  0,  0, 16,
     >           43, 63, 42, 63, 63, 63, 63,  0/
c
c
      cicol = icol

c
      if(iold.eq.0) then
        do i = 1, 16
          itmp  = rgb(red(i),grn(i),blu(i))
          dummy4 = remappalette(i-1,itmp)
        end do
      end if
c
      cicol = icol 
      dummy = settextcolor( cicol )
      dummy = setcolor( cicol )

      if(lout.eq.0) return
      i = icol + 1
      if(icol.eq.1) i = 1
c      write(lout,1) float(red(i))/63.0, float(grn(i))/63.0, 
c     >              float(blu(i))/63.0
1     format(2x,3(f4.2,1x),'srgb')
c      
      return
      end
c----------------------------------------------------------------------
      subroutine plot(x,y,jpen)
c----------------------------------------------------------------------

      include 'fgraph.fd'
      integer*2 dummy, newx, newy
      record /xycoord/ xy

      real    x, y, xx, yy, xorg, yorg, scal, lastx, lasty, psscale
      integer ipen, jpen, iold, icount, lout
      logical plt
      common /origin/ xorg, yorg, scal
      common /output/ lout, iold, lastx, lasty, psscale, icount
      common /lastcall/ plt
c
      ipen = jpen
      xx = x * scal + xorg
      yy = y * scal + yorg
      if(ipen.eq.-3) then
        xorg = xx
        yorg = yy
        ipen = 3
      end if

      if(ipen.eq.3) call moveto(newx(xx),newy(yy),xy)
      if(ipen.eq.2) dummy = lineto(newx(xx),newy(yy))

c
      if(lout.eq.0) return
c
      if(ipen.eq.2) then
c
c The IOLD refers to last call to PLOT. Used to eliminate sequential moves
c that do not draw anything
c
        if(plt.and.iold.eq.3) then
          write(lout,5)
          write(lout,3) lastx, lasty
          icount = 1
        end if
        write(lout,2) xx*psscale, yy*psscale
        icount = icount + 1
        if(icount.gt.1000) then
          write(lout,4)
          write(lout,5)
          write(lout,3) xx*psscale, yy*psscale
          icount = 1
        end if
c
c Move the pen without drawing
c
       else if(ipen.eq.3) then
        if(plt.and.iold.eq.2) write(lout,4)
        lastx = xx * psscale
        lasty = yy * psscale
      end if
      iold = ipen
      plt = .true.
4     format('s')
5     format('n')
2     format(2(f6.1,1x),'l')
3     format(2(f6.1,1x),'m')

      return
      end
c-------------------------------------------------------------------------
      subroutine symbol(x,y,hite,string,theta,nchars)
c-------------------------------------------------------------------------

      include   'fgraph.fd'
      character  font*10/"t'modern'"/
      character width*2, height*2
      integer*2 dummy, newx, newy, newh, neww, maxx, maxy
      record /xycoord/ xy

      integer   nchars, lout, iold, icount
      character string*(*),iostring*(80)
      real      x, y, hite, theta, xx, yy, hhite, xorg, yorg, scal
      real      lastx, lasty, psscale, hiteold/0.0/
      logical plt
      common /origin/ xorg, yorg, scal
      common /output/ lout, iold, lastx, lasty, psscale, icount
      common /lastcall/ plt
c
      xx = x * scal + xorg
      yy = y * scal + yorg
      hhite = hite * scal
      iostring = string(1:nchars)
      call trunc(iostring,nchars)
      if(nchars.eq.0) return

      write(height,'(i2)') max(newh(hhite*1.6),1)
      write(width,'(i2)')  max(nint(neww(hhite*1.4)*.5),1)
      call trunc(height,i)
      call trunc(width,j)
      dummy = setfont( font//'h'//height(1:i)//'w'//width(1:j)//'v' )
c
c 999 is a code to continue plotting from end of the last string - 
c coordinates are only needed for the postscript file.
c
      if(x.eq.999.0.and.y.eq.999.0) then
        call outgtext(iostring(1:nchars))
       else
        call moveto(newx(xx),newy(yy+hhite),xy)
        call outgtext(iostring(1:nchars))
      end if

c
      if( lout .eq. 0 ) return
c
c 999 is a code to continue plotting from end of the last string - 
c coordinates are only needed for the postscript file.
c
c Postscript fonts set in opnplt
c
      if(plt.and.iold.eq.1) write(lout,2)
1     format('s')
      if(hite.ne.hiteold) then
        write(lout,4) nint(hhite*psscale)
4       format('/fontsize ',i2,' def font findfont fontsize ',
     >         'scalefont setfont')
      end if
      if(x.eq.999.0.and.y.eq.999.0) then
        write(lout,5) iostring(1:nchars)
5       format('currentpoint moveto (',a,') show')
       else
        xx = xx * psscale
        yy = yy * psscale
        if(theta.eq.0.0) then
          write(lout,2) xx, yy, iostring(1:nchars)
         else
          write(lout,3) xx, yy, theta, iostring(1:nchars)
        end if
      end if
      hiteold = hite
2     format(1x,2(f7.2,1x),' m (',a,') show')
3     format(1x,2(f7.2,1x),' m gsave ',f5.1,' rotate (',a,
     >       ') show grestore')
      plt = .false.

      return
      end
c-------------------------------------------------------------------------
       subroutine number(x,y,hite,rnumber,theta,fmt)
c-------------------------------------------------------------------------
      character iostring*80, iofmt*20, fmt*(*) 
      real      x, y, hite, theta, rnumber
      integer   nchars
c
      iofmt = fmt
      call shiftup(iofmt)
      call trunc(iofmt,nchars)
      if(index(iofmt(:nchars),'I').eq.0) then
        write(iostring,'('//iofmt(1:nchars)//')',err=1) rnumber
       else
        write(iostring,'('//iofmt(1:nchars)//')',err=1) nint(rnumber)
      end if
      call trunc(iostring,nchars)
      call symbol(x,y,hite,iostring(1:nchars),theta,nchars)
1     return
      end
