#include <stdio.h>
#include <string.h>
#ifdef FILENAME_MAX	/* defined in stdio.h only for SunOS >=5.x */
#define SYSV
#endif

#include <errno.h>
#include <fcntl.h>
#include <sys/types.h>
#ifdef SYSV
#include <sys/stat.h>
#else
#define FILENAME_MAX 1024
#endif
/*
 * c_open_new_file : given a path create a new file and return file descriptor
 *                   if an error occurs return a NULL and set errnum
 */
FILE *c_open_new_file_ (path,errnum,path_len)
char *path;
int *errnum;
int path_len;
{
     int fd;
     int i;
     char path_tmp[FILENAME_MAX];
     int pl_tmp;   /* tmp path_len, we need to return path_len undisturbed */

     *errnum=0;

     pl_tmp = path_len;
     strcpy(path_tmp,path);
     /*
      * strip off trailing blanks in path, otherwise filename will contain spaces
      */
     for (i=pl_tmp-1; path_tmp[i] == ' '; --i) {
#ifdef DEBUG
	  fprintf(stdout," i path_tmp[i] %d, %c\n", i, path_tmp[i]);
#endif
     }
     path_tmp[i+1]='\0';
#ifdef DEBUG
     fprintf(stdout," the file to open new is %s\n",path_tmp);
#endif     

     /*
      * create file exclusively for write, rw by owner, r only by group and other
      */
#ifdef SYSV
     if( (fd=open(path_tmp, O_CREAT|O_WRONLY|O_EXCL))==-1) {
	  *errnum=errno;
	  return (FILE *)-1;
     }
     if ( chmod(path_tmp, S_IRUSR|S_IWUSR|S_IRGRP|S_IROTH)==-1) {
	  *errnum=errno;
	  return (FILE *)-1;
     }
     return fdopen(fd,"w");
#else
     if( (fd=open(path_tmp, O_CREAT|O_WRONLY|O_EXCL, S_IRUSR|S_IWUSR|S_IRGRP|S_IROTH))==-1) {
	  *errnum=errno;
	  return (FILE *)-1;
     }
     return fdopen(fd,"w");
#endif
}
/*
 * c_open_old_file : given a path to an old file, open it and return file descriptor
 *                   if an error occurs return a NULL and set errnum
 */
FILE *c_open_old_file_ (path,errnum,path_len)
char *path;
int *errnum;
int path_len;
{
     
     int fd;
     int i;
     char path_tmp[FILENAME_MAX];
     int pl_tmp;

     *errnum=0;
     
     pl_tmp = path_len;
     strcpy(path_tmp,path);
     /*
      * strip off trailing blanks in path, otherwise filename will contain spaces
      */
     for (i=pl_tmp-1; path_tmp[i] == ' '; --i) {
#ifdef DEBUG
	  fprintf(stdout," i path_tmp[i] %d, %c\n", i, path_tmp[i]);
#endif
     }
     path_tmp[i+1]='\0';
#ifdef DEBUG
     fprintf(stdout," the file to open old (ro) is %s\n",path_tmp);
#endif

     /*
      * open file for read only
      */
     if( (fd=open(path_tmp, O_RDONLY))==-1) {
	  *errnum=errno;
	  return (FILE *) -1;
     }
     return fdopen(fd,"r");
}
/*
 * c_close: close a mpfile
 *  must be called from from mpclose() which must be called in main fortran
 *  program
 */
int c_close_ (fd)
FILE **fd;
{
#ifdef DEBUG
     fprintf(stdout,"fd in c_close is %d\n",fd);
#endif
     return fclose(*fd);
}
int c_write_ (fd,buf,nbytes,buf_len)

FILE **fd;
char *buf;
int *nbytes,buf_len;

{
     return fwrite(buf,1,*nbytes,*fd);
}
int c_read_ (fd,buf,nbytes,buf_len)

FILE **fd;
char *buf;
int *nbytes,buf_len;

{
     return fread(buf,1,*nbytes,*fd);
}

