      subroutine cohmax7

	implicit none
c
c     routine to derive the coherences of the horizontal magnetic
c     and electric fields and derive the maximum coherence direction and
c     coherence difference in that direction
c

      include 'maxflims.inc'

      complex s7, ss(7,7)
      integer n, ndevm, ndev, i, j, k, ic1, ic2
      real    delta, tlen, period, theta
      real    r1, ratx1, focoh
      real    r2, ratx2, prd, cer, chr

	real    ce, cemin, ceminang, cemax, cemaxang

	real    ch, chmin, chminang, chmax, chmaxang

      common /time/ delta,tlen,period(MAXF)
      common /power7/ s7(7,7,MAXF)
      common /nwrite/ ndev, ndevm
      common n
c
c     subroutine to compute the polarisation parameters
c     *note* must compile with array bound checking off
c
      if( ndevm .ne. 0 ) write(ndevm,3333)
 3333 format(5x,'==>subroutine cohmax entered')

      write(ndev,100)
      write(ndev,101)
      write(ndev,103)
      write(ndev,104)
  100 format(//,10x,'coherence rotation parameters')
  101 format(/, 3x,'cohx  = angle of maximum coh to the north',
     &    /,    3x,'cohm  = angle of minimum coh to the north',
     &    /,    3x,'ratio = major/minor coh',
     &    /,    3x,'r     = coh difference')
  103 format(/,26x,'for magnetic field',17x,'for telluric field')
  104 format(/,9x,'period',4x,'cohx',4x,'cohm',4x,'r',
     &    2x,'ratio',1x,'ic1',4x,'cohx',4x,'cohm',4x,'r',
     &    2x,'ratio',1x,'ic2')
 
      do i=1,n

c...rotate around by 180 degrees to find maximum and minimum coherences 
c   for S(Hx,Hy) and S(Ex,Ey)

        ch = focoh( 7, s7(1,1,i), 1, 2 )
        ce = focoh( 7, s7(1,1,i), 3, 4 )
        chmax = ch
        chmaxang = 0.
        chmin = ch
        chminang = 0.
        cemax = ce
        cemaxang = 0.
        cemin = ce
        ceminang = 0.

        do theta = 0., 180., 1.

          do j = 1, 7
            do k = 1, 7
              ss(j,k) = s7(j,k,i)
            enddo
          enddo
          call rotss7( theta, ss )

          chr = focoh( 7, ss, 1, 2 )
          cer = focoh( 7, ss, 3, 4 )

          if( chr.gt.chmax ) then
            chmax    = chr
            chmaxang = theta
          endif
          if( chr.lt.chmin ) then
            chmin    = chr
            chminang = theta
          endif

          if( cer.gt.cemax ) then
            cemax    = cer
            cemaxang = theta
          endif
          if( cer.gt.cemin ) then
            cemin    = cer
            ceminang = theta
          endif

        enddo

        ratx1 = chmax/chmin
        ratx2 = cemax/cemin
        r1 = chmax - chmin
        r2 = cemax - cemin

        if( period(i).gt.1. ) then
          prd = period(i)
        else
          prd = -1./period(i)
        endif
        write(ndev,102)i,period(i),chmaxang,chminang,r1,ratx1,ic1,
     &               cemaxang,ceminang,r2,ratx2,ic2
  102   format(1x,i3,1x,1pe10.3,1x,0p4f7.2,2x,i1,1x,4f7.2,2x,i1)

      enddo

      return
      end
