      subroutine gethardware( indat, instr, nchan, calibs, 
     &                                               cutsl, cutsh )
c---------------------------------------------------------------------
c
c     GETHARDWARE: gets hardware calibrations from hardware file  
c
c---------------------------------------------------------------------
 
      real calibs(*), cutsl(*), cutsh(*), calib, cutlo, cuthi
      integer indat, instr, nchan, instrx, ichan, ic, i
      character comp*1, ans*1

      include 'ctrlblk.inc' 
 
c----------------------------------------------------------------------
c locate calibration parameters etc. from project file

      rewind( indat, err=9999 )
      instrx = -1

      if( iprint.ge.2 ) then
        write(*,*)'gethardware: entered with instr=',instr,
     &            '   nchan=', nchan
      end if

      do while( instrx.ne.instr ) 
10      continue
        read( indat, '(i3)', end=9999, err=10 ) instrx
        if( instrx.eq.instr ) goto 1
      end do

    1 if( iprint.ge.1 ) then
        write(*,*) 'gethardware: instrument located =', instr
      end if

      do ichan = 1, nchan
        read( indat,* ) comp, calib, cutlo, cuthi
        if( iprint.ge.2 ) write(*,*) comp, calib, cutlo,cuthi
        if( comp.eq.'H' ) then
          calibs(1) = calib
          cutsl(1)  = cutlo
          cutsh(1)  = cuthi
        else if( comp.eq.'D' ) then
          calibs(2) = calib
          cutsl(2)  = cutlo
          cutsh(2)  = cuthi
        else if( comp.eq.'Z' ) then
          calibs(5) = calib
          cutsl(5)  = cutlo
          cutsh(5)  = cuthi
        else if( comp.eq.'N' ) then
          calibs(3) = calib
          cutsl(3)  = cutlo
          cutsh(3)  = cuthi
        else if( comp.eq.'E' ) then
          calibs(4) = calib
          cutsl(4)  = cutlo
          cutsh(4)  = cuthi
        else
          write(*,*)'gethardware: ERROR:  Unrecognisable component in ',
     &                'hardware file, comp=',comp
          stop
        end if
      end do

      if( iprint.ge.1 ) then
        write(*,*)'gethardware: leaving with following calibs & cuts =>'
        do ic = 1, nchan
          i = ic
          if( nchan.eq.3 .and.ic.eq.3 ) i = 5
          write(*,*) 'channel=',i, calibs(i), cutsl(i), cutsh(i)
        end do
      end if
 
      return
 
 9999 write(*,*)'gethardware: ERROR: Cannot locate instrument ',
     &    'requested in hardware file, instrument = ', instr
      ans = 'y'
      call yin( 'Use default LiMS settings', ans )
      if( ans.eq.'Y' ) then
        write(*,*)' using LiMS default values '
        write(*,*)' 0.2 s anti-alias Bessel low pass on all channels'
        write(*,*)' 30,000 s Butterworth high pass on E channels only'
        do i = 1, 5
          calibs(i) = 1.0
          cutsl(i)  = 0.2
          cutsh(i)  = 0.0
        enddo
          cutsh(4) = 30000.
          cutsh(5) = 30000.
      else
        write(*,*)' using no default values '
        do i = 1, 5
          calibs(i) = 1.0
          cutsl(i)  = 0.0
          cutsh(i)  = 0.0
        enddo
      endif

      return
  
      end
