      SUBROUTINE HIPASS(N,X,TCUT,DELTA, worksp)

      REAL X(*),E(3),D(2), worksp(*), b, c, w, tcut, delta,
     &     teq, weq, ceq, beq
      integer i, n
C
C     BUTTERWORTH 2ND. ORDER FILTER (HIGH-PASS) RUN FORWARDS AND
C     BACKWARDS OVER DATA TO GIVE ZERO PHASE SHIFT AND -12DB/OCTAVE
C      REFERENCE: KULHANEK (1976) PP87-92,95-96 & NOTES(JONES)
C

      include 'ctrlblk.inc'

      if( iprint.ge.2 ) then
        write(*,*)'hipass: entered with n,tcut,delta=',n,tcut,delta
      endif

      W=TAN(3.141592*DELTA/TCUT)
      B=W*(SQRT(2.0))
      C=W*W
      E(1)=1./(1.+B+C)
      E(2)=-2.*E(1)
      E(3)=E(1)
C         *DETERMINE 'EQUIVALENT' CUT-OFF PERIOD
      TEQ=( 2.*DELTA*TCUT ) / ( TCUT - 2.*DELTA )
      WEQ=TAN(3.141592*DELTA/TEQ)
      BEQ=WEQ*(SQRT(2.0))
      CEQ=WEQ*WEQ
      D(1)=-2.*(CEQ-1.)/(1.+BEQ+CEQ)
      D(2)=(1.-BEQ+CEQ)/(1.+BEQ+CEQ)

      CALL FILTER(X,E,D,N, worksp)

      if(iprint.ge.2)WRITE(*,2001)N,TCUT,DELTA,(E(I),I=1,3),
     & (D(I),I=1,2)
 2001 FORMAT(/,5X,'HIPASS : N=',I5,'  TCUT=',E9.3,'  DELTA=',
     ?E9.3,/,5X,'COEFFICIENTS==> (',E10.4,' ) + (',E10.4,' ) + (',
     ?E10.4,' ) / ( 1. ) + (',E10.4,' ) + (',E10.4,' )' )

      if( iprint.ge.2 ) then
        write(*,*)'hipass: returning'
      endif

      RETURN
      END
 
