      subroutine minvar7( mt, n, yy, nnew, y0 )
c-------------------------------------------------------------------

      implicit none
      
      real yy(64,49), y0(49), y(49), mcoh1, mcoh2, ocoh, f1(64)
      real f2(64), mcoh, frccf1, frccf2, focoh, fmcoh, varml
      real r32, r41, r51, r52, varcst, varmin, var, s1, s2
      real vartol
      integer iflag(64), n, nnew, i, j, imiss, irej, m, imin
      complex s7(7,7)
      character*1 mt

c   mt: character*1 variable
c                   = M: MT  processing
c                   = G: GDS processing
c                   = H: HSG processing
 
      external frccf1, frccf2

      common /vartol/ vartol

      include 'ctrlblk.inc'
  

c---F values for F(2:n-2:0.05); where n = 2xno of estimates
      data f1/ 0.00,19.00, 6.94, 5.14, 4.46, 4.10, 3.89, 3.74,
     &         3.63, 3.55, 3.49, 3.44, 3.40, 3.37, 3.34, 3.32, 
     &         3.30, 3.28, 3.26, 3.24, 3.23, 3.22, 3.21, 3.20,
     &        3.191,3.183,3.175,3.168,3.162,3.156,3.150,3.145,
     &        3.140,3.136,3.132,3.128,3.124,3.120,3.117,3.114,
     &        3.111,3.108,3.105,3.103,3.100,3.098,3.095,3.093,
     &        3.091,3.089,3.087,3.085,3.084,3.082,3.080,3.079,
     &        3.077,3.076,3.074,3.073,3.072,3.071,3.069,3.068 /


c---F values for F(4:n-4:0.05); where n = 2xno of estimates
      data f2/ 0.0,  0.0,19.25, 6.39, 4.53, 3.84, 3.48, 3.25,
     &        3.11, 3.01, 2.93, 2.87, 2.82, 2.78, 2.74, 2.71,
     &        2.69, 2.67, 2.65, 2.62, 2.61, 2.60, 2.59, 2.58,
     &       2.574,2.565,2.557,2.550,2.543,2.537,2.531,2.525,
     &       2.520,2.515,2.511,2.507,2.503,2.499,2.495,2.492,
     &       2.489,2.486,2.483,2.480,2.478,2.475,2.473,2.471,
     &       2.469,2.466,2.465,2.463,2.461,2.459,2.457,2.456,
     &       2.454,2.453,2.451,2.450,2.449,2.447,2.446,2.445 /
 
 

      if( iprint.ge.2 ) then
        write(*,*)'minvar7: entered with mt=',mt,'   n=', n
      endif

 
      do i = 1, n
        iflag(i) = 1
      end do
 
c---sum up all data into array "y0"
      do j = 1, 49
        y0(j) = 0.
        do i = 1, n
          y0(j) = y0(j) + yy(i,j)
        enddo
      enddo
 
      call acspec7( y0, s7 )
 
      ocoh = focoh( 7, s7, 1, 2 )
      if( ocoh.eq.0. ) then
        if( iprint.ge.1 ) then
          write(*,*)'minvar1: ocoh = 0 - all set to zero'
        endif
        nnew = 0
        return
      endif

      if( mt.eq.'M' ) then
        mcoh1 = fmcoh( 7, s7, 3,  1, 2 )
        mcoh2 = fmcoh( 7, s7, 4,  1, 2 )
        if( mcoh1.eq.0. .or. mcoh2.eq.0. ) then
          if( iprint.ge.1 ) then
            write(*,*)'minvar1: mcoh1 or mcoh2 = 0 - all set to zero'
          endif
          nnew = 0
          return
        endif
      else if( mt.eq.'G' ) then
        mcoh  = fmcoh( 7, s7, 5,  1, 2 )
      else if( mt.eq.'H' ) then
        ocoh = focoh( 7, s7, 1, 5 )
      else
        write(*,*) 'minvar7: ERROR: unpermitted character supplied ',
     &                       'for mt =', mt
        stop
      endif

      if( iprint.ge.3 ) then
        write(*,*)'Powers ==>'
        write(*,*)'  H  = ', real(s7(1,1))
        write(*,*)'  D  = ', real(s7(2,2))
        write(*,*)'  N  = ', real(s7(3,3))
        write(*,*)'  E  = ', real(s7(4,4))
        write(*,*)'  Z  = ', real(s7(5,5))
        write(*,*)'  R1 = ', real(s7(6,6))
        write(*,*)'  R2 = ', real(s7(7,7))
      endif

      if( mt.eq.'M' ) then 
        r32 = frccf2(2*n,f2(n),mcoh1,ocoh,real(s7(3,3)),real(s7(2,2)))
        r41 = frccf2(2*n,f2(n),mcoh2,ocoh,real(s7(4,4)),real(s7(1,1)))
        varml = sqrt( r32*r41 )
      else if( mt.eq.'G' ) then
        r51 = frccf2(2*n,f2(n),mcoh,ocoh,real(s7(5,5)),real(s7(1,1)))
        r52 = frccf2(2*n,f2(n),mcoh,ocoh,real(s7(5,5)),real(s7(2,2)))
        varml = sqrt( r51*r52 )
      else if( mt.eq.'H' ) then
        varml = frccf1( 2*n,f1(n),ocoh,real(s7(5,5)),real(s7(1,1)))
      end if

      if( iprint.ge.2 ) then
        if( mt.eq.'M' ) then
          write(*,*)'minvar7: starting sds ==>',r32, r41,'varml =',varml
          write(*,*)'    ocoh, mcoh1, mcoh2 =>', ocoh, mcoh1, mcoh2
        else if( mt.eq.'G' ) then
          write(*,*)'minvar7: starting sds ==>',r51, r52,'varml =',varml
          write(*,*)'    ocoh, mcoh =>', ocoh, mcoh
        else if( mt.eq.'H' ) then
          write(*,*)'minvar7: starting sd & ocoh ==>', varml, ocoh
        endif
      end if

      do 10 irej = 1, n-4
        m = n-irej
 
        varcst = 1.E20
        varmin = varcst

        if( iprint.ge.3 ) write(*,*) 'irej ==>', irej

        do 20 imiss = 1, n
          if( iflag(imiss).eq.0 ) goto 20
 
c---remove IMISS component and place into array "y"
          do i = 1, 49
            y(i) = y0(i) - yy(imiss,i)
          end do
 
          call acspec7( y, s7 )
 
          ocoh  = focoh( 7, s7, 1, 2 )

          if( mt.eq.'M' ) then
            mcoh1 = fmcoh( 7, s7, 3,  1, 2 )
            mcoh2 = fmcoh( 7, s7, 4,  1, 2 )
            r32 = frccf2( 2*m, f2(m), mcoh1, ocoh,
     &                  real(s7(3,3)),real(s7(2,2)))
            r41 = frccf2( 2*m, f2(m), mcoh2, ocoh,
     &                  real(s7(4,4)),real(s7(1,1)))
            if( r32.gt.0. .and. r41.gt.0. ) then
              var = sqrt( r32*r41 )
            else
              var = -1.
            endif
          else if( mt.eq.'G' ) then
            mcoh = fmcoh( 7, s7, 5,  1, 2 )
            r51 = frccf2( 2*m, f2(m), mcoh, ocoh,
     &                  real(s7(5,5)),real(s7(1,1)))
            r52 = frccf2( 2*m, f2(m), mcoh, ocoh,
     &                  real(s7(5,5)),real(s7(2,2)))
            if( r51.gt.0. .and. r52.gt.0. ) then
              var = sqrt( r51*r52 )
            else
              var = -1.
            endif
          else if( mt.eq.'H' ) then
            ocoh  = focoh( 7, s7, 1, 5 )
            var = frccf1( 2*m,f1(m),ocoh,real(s7(5,5)),real(s7(1,1)))
          end if

c...check for negative variance. If found, then set to high value (varcst)
          if( var.le.0. ) then
             if( iprint.ge.1 ) then
               write(*,*)'minvar7: WARNING - ZERO OR NEGATIVE VARIANCE!'
               write(*,*)'m=', m, ' f2(m)=', f2(m),' r32, r41= ',r32,r41
               write(*,*)'mcoh1=', mcoh1, 'ocoh =', ocoh
               s1 = real(s7(3,3))
               s2 = real(s7(2,2))
               write(*,*)'real (s7(3,3))=', s1, '  real (s7(2,2))=', s2
               write(*,*)'mcoh2 =', mcoh2, 'ocoh =', ocoh
               s1 = real(s7(4,4))
               s2 = real(s7(1,1))
               write(*,*)'real (s7(4,4))=', s1, '  real (s7(1,1))=', s2
             endif
             var = varcst
          endif
          
          
          if( iprint.ge.3 ) then
            write(*,*)'imiss, r32, r41 ==>', imiss, r32, r41
            write(*,*)'ocoh, mcoh1, mcoh2 =>', ocoh, mcoh1, mcoh2
          end if

           if( var.lt.varmin ) then
             imin   = imiss
             varmin = var
           end if


   20   continue
 
        if( iprint.ge.2 ) then
        write(*,'(a,i2,a,i2,a,1pe10.3,a,e10.3,a,e10.3)')' Cycle=',irej,
     &                             '  imin=',imin,' varmin=', varmin,
     &                             '  var=', var, '  varml=', varml
        end if

c...check if minimum found on last iteration, to within 'vartol' tolerance
        if( varmin*(1.+vartol) .gt. varml ) then
           if( iprint.ge.2 ) then
             write(*,*)'Minimum found - returning with varmin = ', varml
             call pause('Press <ENTER> to continue...')
           endif
           nnew = n-irej+1
          return
        end if
 
c...check if the variance after the first pass is equal to varcst.
        if (varmin .eq. varcst) then
           if( iprint.ge.2 ) then
             write(*,*)'minvar7: returning to STACK, var greater than ',
     &               varcst
           endif
          nnew = n - irej + 1
          return
        end if
 
c---mimimum found, remove IMIN from array "y0"
        iflag(imin) = 0
        do i = 1, 49
          y0(i) = y0(i) - yy(imin,i)
        end do
 
        varml = varmin
 
   10 continue
 
c      write(*,*)'No minimum found '
      nnew = 3
      return
      end
