      subroutine pha_plrzn7
c
c     routine to derive the phase ellipses of the horizontal magnetic
c     and electric fields and give the maximum ellipse direction and
c     phase difference in that direction
c

      include 'maxflims.inc'

      integer npre,epre,hpre,dpre,zpre,rxpre,rypre
      complex s7, shr, ser
      integer n, ndevm, ndev, i, ic1, ic2
      real    delta, tlen, period, theta
      real    r1, ratx1, r2, ratx2, prd
      common /time/ delta,tlen,period(MAXF)
      common /pres7/ npre,epre,hpre,dpre,zpre,rxpre,rypre
      common /power7/ s7(7,7,MAXF)
      common /nwrite/ ndev, ndevm
      common n
c
c     subroutine to compute the polarisation parameters
c     *note* must compile with array bound checking off
c
      if( ndevm .ne. 0 ) write(ndevm,3333)
 3333 format(5x,'==>subroutine pha_plrzn entered')

      write(ndev,100)
      write(ndev,101)
      write(ndev,103)
      write(ndev,104)
  100 format(//,10x,'phase polarisation parameters')
  101 format(/ ,3x,'psix  = angle of maximum axis to the north',
     &    /,    3x,'psim  = angle of minimum axis to the north',
     &    /,    3x,'ratio = major/minor axis',
     &    /,    3x,'r     = phase difference')
  103 format(/,26x,'for magnetic field',17x,'for telluric field')
  104 format(/,9x,'period',4x,'psix',4x,'psim',4x,'r',
     &    2x,'ratio',1x,'ic1',4x,'psix',4x,'psim',4x,'r',
     &    2x,'ratio',1x,'ic2')
 
      do i=1,n

c...rotate around by 180 degrees to find maximum and minimum phases 
c   for S(Hx,Hy) and S(Ex,Ey)

        ph = atan2d(aimag(s7(1,2,i)),real(s7(1,2,i)))
        pe = atan2d(aimag(s7(3,4,i)),real(s7(3,4,i)))
        phmax = ph
        phmaxang = 0.
        phmin = ph
        phminang = 0.
        pemax = pe
        pemaxang = 0.
        pemin = pe
        peminang = 0.
        do theta = 0., 180., 1.
          d = cosd(theta)
          e = sind(theta)
          a = d*d
          b = e*e
          c = d*e
          shr=s7(1,2,i)*a -s7(2,1,i)*b +(s7(2,2,i)-s7(1,1,i))*c
          ser=s7(3,4,i)*a -s7(4,3,i)*b +(s7(4,4,i)-s7(3,3,i))*c

          phr = atan2d(aimag(shr),real(shr))
          per = atan2d(aimag(ser),real(ser))

          if( phr.gt.phmax ) then
            phmax    = phr
            phmaxang = theta
          endif
          if( phr.lt.phmin ) then
            phmin    = phr
            phminang = theta
          endif

          if( per.gt.pemax ) then
            pemax    = per
            pemaxang = theta
          endif
          if( per.gt.pemin ) then
            pemin    = per
            peminang = theta
          endif
        enddo

        ratx1 = phmax/phmin
        ratx2 = pemax/pemin
        r1 = phmax - phmin
        r2 = pemax - pemin

        if( period(i).gt.1. ) then
          prd = period(i)
        else
          prd = -1./period(i)
        endif
        write(ndev,102)i,period(i),phmaxang,phminang,r1,ratx1,ic1,
     &               pemaxang,peminang,r2,ratx2,ic2
  102   format(1x,i3,1x,1pe10.3,1x,0p4f7.2,2x,i1,1x,4f7.2,2x,i1)

      enddo

      return
      end
