      SUBROUTINE rotss7( angle, ss )
c
      integer j, i
      real    theta, a, b, c, d, e, angle
      complex ss(7,7), sx(7,7)
C
C     SUBROUTINE ROTATES THE POWER MATRIX  SS  BY ANGLE  'ANGLE'
C
C     ALL VECTORS ROTATED, including Hz
c


      THETA=ANGLE*3.141592/180.
      D = COS(THETA)
      E = SIN(THETA)
      A = D*D
      B = E*E
      C = D*E
C
      sx(1,1)=ss(1,1)*A +ss(2,2)*B +(ss(1,2)+ss(2,1))*C
      sx(1,2)=ss(1,2)*A -ss(2,1)*B +(ss(2,2)-ss(1,1))*C
      sx(1,3)=ss(1,3)*A +ss(2,4)*B +(ss(1,4)+ss(2,3))*C
      sx(1,4)=ss(1,4)*A -ss(2,3)*B +(ss(2,4)-ss(1,3))*C
      sx(1,6)=ss(1,6)*A +ss(2,7)*B +(ss(1,7)+ss(2,6))*C
      sx(1,7)=ss(1,7)*A -ss(2,6)*B +(ss(2,7)-ss(1,6))*C
      sx(2,2)=ss(2,2)*A +ss(1,1)*B -(ss(1,2)+ss(2,1))*C
      sx(2,3)=ss(2,3)*A -ss(1,4)*B +(ss(2,4)-ss(1,3))*C
      sx(2,4)=ss(2,4)*A +ss(1,3)*B -(ss(2,3)+ss(1,4))*C
      sx(2,6)=ss(2,6)*A -ss(1,7)*B +(ss(2,7)-ss(1,6))*C
      sx(2,7)=ss(2,7)*A +ss(1,6)*B -(ss(2,6)+ss(1,7))*C
      sx(3,3)=ss(3,3)*A +ss(4,4)*B +(ss(3,4)+ss(4,3))*C
      sx(3,4)=ss(3,4)*A -ss(4,3)*B +(ss(4,4)-ss(3,3))*C
      sx(3,6)=ss(3,6)*A +ss(4,7)*B +(ss(3,7)+ss(4,6))*C
      sx(3,7)=ss(3,7)*A -ss(4,6)*B +(ss(4,7)-ss(3,6))*C
      sx(4,4)=ss(4,4)*A +ss(3,3)*B -(ss(3,4)+ss(4,3))*C
      sx(4,6)=ss(4,6)*A -ss(3,7)*B +(ss(4,7)-ss(3,6))*C
      sx(4,7)=ss(4,7)*A +ss(3,6)*B -(ss(4,6)+ss(3,7))*C
      sx(6,6)=ss(6,6)*A +ss(7,7)*B +(ss(6,7)+ss(7,6))*C
      sx(6,7)=ss(6,7)*A -ss(7,6)*B +(ss(7,7)-ss(6,6))*C
      sx(7,7)=ss(7,7)*A +ss(6,6)*B -(ss(6,7)+ss(7,6))*C
c
c rotate xpower with Hz just once 
c
      sx(5,5) = ss(5,5)
      sx(1,5) = ss(1,5)*d + ss(2,5)*e
      sx(2,5) =-ss(1,5)*e + ss(2,5)*d
      sx(3,5) = ss(3,5)*d + ss(4,5)*e
      sx(4,5) =-ss(3,5)*e + ss(4,5)*d
      sx(5,6) = ss(5,6)*d + ss(5,7)*e
      sx(5,7) =-ss(5,6)*e + ss(5,7)*d

      sx(2,1)=CONJG(sx(1,2))
      sx(3,1)=CONJG(sx(1,3))
      sx(3,2)=CONJG(sx(2,3))
      sx(4,1)=CONJG(sx(1,4))
      sx(4,2)=CONJG(sx(2,4))
      sx(4,3)=CONJG(sx(3,4))
      sx(5,1)=CONJG(sx(1,5))
      sx(5,2)=CONJG(sx(2,5))
      sx(5,3)=CONJG(sx(3,5))
      sx(5,4)=CONJG(sx(4,5))
      sx(6,1)=CONJG(sx(1,6))
      sx(6,2)=CONJG(sx(2,6))
      sx(6,3)=CONJG(sx(3,6))
      sx(6,4)=CONJG(sx(4,6))
      sx(6,5)=CONJG(sx(5,6))
      sx(7,1)=CONJG(sx(1,7))
      sx(7,2)=CONJG(sx(2,7))
      sx(7,3)=CONJG(sx(3,7))
      sx(7,4)=CONJG(sx(4,7))
      sx(7,5)=CONJG(sx(5,7))
      sx(7,6)=CONJG(sx(6,7))

      do j = 1, 7
        do i = 1, 7
          ss(i,j) = sx(i,j)
        enddo
      enddo

      RETURN
      END
