      subroutine ts_wrtinfo( outd )
      integer outd

c...writes info block from input file (must be open already)

      character line*80

      integer ichan

      logical ASCII

      include 'infoblk.inc'
      include 'ctrlblk.inc'

      if( iprint.ge.1 ) then
        write(*,*)'ts_wrtinfo: entered with format =',format
      endif

      if( form.eq.'BINARY' ) then
        ASCII = .FALSE.
      else
        ASCII = .TRUE.
      endif



c...info start

      line = '>INFO_START:'

      if( ASCII ) then

        write(outd,'(a)') line

      else

        write(outd) line

      endif


c...station
      line = '>STATION'
      line(12:) = ':'
      line(13:) = stat
      if( ASCII ) then
        write(outd,'(a)') line
      else
        write(outd) line
      endif

c...instrument
      line = '>INSTRUMENT'
      line(12:) = ':'
      write(line(13:),*) instrument
      if( ASCII ) then
        write(outd,'(a)') line
      else
        write(outd) line
      endif

c...window
      line = '>WINDOW'
      line(12:) = ':'
      line(13:) = window
      if( ASCII ) then
        write(outd,'(a)') line
      else
        write(outd) line
      endif

c...latitude
      line = '>LATITUDE'
      line(12:) = ':'
      write( line(13:),*) lat
      if( ASCII ) then
        write(outd,'(a)') line
      else
        write(outd) line
      endif

c...longitude
      line = '>LONGITUDE'
      line(12:) = ':'
      write( line(13:),*) long
      if( ASCII ) then
        write(outd,'(a)') line
      else
        write(outd) line
      endif

c...elevation
      line = '>ELEVATION'
      line(12:) = ':'
      write( line(13:),* ) elev
      if( ASCII ) then
        write(outd,'(a)') line
      else
        write(outd) line
      endif

c...UTM coordinates
      line = '>UTM_ORIGIN'
      line(12:) = ':'
      write( line(13:),* ) utmorigin
      if( ASCII ) then
        write(outd,'(a)') line
      else
        write(outd) line
      endif

      line = '>UTM_NORTH'
      line(12:) = ':'
      write( line(13:),* ) utmn
      if( ASCII ) then
        write(outd,'(a)') line
      else
        write(outd) line
      endif

      line = '>UTM_EAST'
      line(12:) = ':'
      write( line(13:),* ) utme
      if( ASCII ) then
        write(outd,'(a)') line
      else
        write(outd) line
      endif

c...coordinate system
      line = '>COORD_SYS'
      line(12:) = ':'
      line(13:) = azdir
      if( ASCII ) then
        write(outd,'(a)') line
      else
        write(outd) line
      endif

c...declination
      line = '>DECLIN'
      line(12:) = ':'
      write(line(13:),*) declination
      if( ASCII ) then
        write(outd,'(a)') line
      else
        write(outd) line
      endif

c...form
      line = '>FORM'
      line(12:) = ':'
      if( ASCII ) then
        line(13:) = 'ASCII'
        write(outd,'(a)') line
      else
        line(13:) = 'BINARY'
        write(outd) line
      endif

c...format
      line = '>FORMAT'
      line(12:) = ':'
      if( ASCII ) then
        line(13:) = format
        write(outd,'(a)') line
      else
        line(13:) = 'UNASCII'
        write(outd) line
      endif


c...endian

      line = '>ENDIAN'

      line(12:) = ':'

      if( ASCII ) then

        continue

      else

        line(13:) = 'Big'

        write(outd) line

      endif



c...binary format

      line = '>BIN_FORM'

      line(12:) = ':'

      if( ASCII ) then

        continue

      else

        line(13:) = 'IEEE'

        write(outd) line

      endif



c...seq_rec

      line = '>SEQ_REC'

      line(12:) = ':'

      write( line(13:),* ) seq_rec

      if( ASCII ) then

        write(outd,'(a)') line

      else

        write(outd) line

      endif


c...nchan
      line = '>NCHAN'
      line(12:) = ':'
      write( line(13:),* ) nchan
      if( ASCII ) then
        write(outd,'(a)') line
      else
        write(outd) line
      endif


      do ichan = 1, nchan

c...chan_
      line = '>CHAN_'
      write(line(7:7),'(i1)') ichan
      line(12:) = ':'
      line(13:) = chan(ichan)
      if( ASCII ) then
        write(outd,'(a)') line
      else
        write(outd) line
      endif
c...sensor_
      line = '>SENSOR_'
      write(line(9:9),'(i1)') ichan
      line(12:) = ':'
      write( line(13:),* ) sensor(ichan)
      if( ASCII ) then
        write(outd,'(a)') line
      else
        write(outd) line
      endif
c...azim_
      line = '>AZIM_'
      write(line(7:7),'(i1)') ichan
      line(12:) = ':'
      write( line(13:),* ) azim(ichan)
      if( ASCII ) then
        write(outd,'(a)') line
      else
        write(outd) line
      endif
c...units_
      line = '>UNITS_'
      write(line(8:8),'(i1)') ichan
      line(12:) = ':'
      line(13:) = units(ichan)
      if( ASCII ) then
        write(outd,'(a)') line
      else
        write(outd) line
      endif
c...gain_
      line = '>GAIN_'
      write(line(7:7),'(i1)') ichan
      line(12:) = ':'
      write(line(13:),* ) gain(ichan)
      if( ASCII ) then
        write(outd,'(a)') line
      else
        write(outd) line
      endif
c...baseline_ (for chan(1:1)='H')
      if( chan(ichan)(1:1).eq.'H' ) then
        line = '>BASELINE_'
        write(line(11:11),'(i1)') ichan
        line(12:) = ':'
        write(line(13:),* ) baseline(ichan)
        if( ASCII ) then
          write(outd,'(a)') line
        else
          write(outd) line
        endif
      endif

      enddo

c...starttime
      line = '>STARTTIME'
      line(12:) = ':'
      line(13:) = starttime
      if( ASCII ) then
        write(outd,'(a)') line
      else
        write(outd) line
      endif

c...endtime
      line = '>ENDTIME'
      line(12:) = ':'
      line(13:) = endtime
      if( ASCII ) then
        write(outd,'(a)') line
      else
        write(outd) line
      endif

c...tunits
      line = '>T_UNITS'
      line(12:) = ':'
      line(13:) = tunits
      if( ASCII ) then
        write(outd,'(a)') line
      else
        write(outd) line
      endif

c...delta_t
      line = '>DELTA_T'
      line(12:) = ':'
      write( line(13:), * ) delta
      if( ASCII ) then
        write(outd,'(a)') line
      else
        write(outd) line
      endif

c...misdat
      line = '>MIS_DATA'
      line(12:) = ':'
      write( line(13:), * ) misdat
      if( ASCII ) then
        write(outd,'(a)') line
      else
        write(outd) line
      endif


c...info end

      line = '>INFO_END  :'

      if( ASCII ) then

        write(outd,'(a)') line

      else

        write(outd) line

      endif


      if( iprint.ge.1 ) then
        write(*,*)'ts_wrtinfo: exiting'
      endif

      return
      end
