      program mp2ts



c     Converts "old" LiMS format ver 3 (.1mp) to new format (.ts & .aux)

c

c     Uses v3.x versions of routines to read data in


c


c     Uses FORTRAN preprocessor options on both UNIX and DOS to result


c     in Big Endian IEEE binaries that can be read on either machine.


c


c     v5.0


c     6 Sept 2000: Changed declination call to geomag31


c



      implicit none

      

      include 'version.inc'

      include 'ctrlblk.inc'

      include 'defaults.inc'

      include 'io.inc'

      include 'op_sys.inc'

      include 'bdate.inc'

      

      character*1 type

      character form*20

      logical FORMATTED, VERIFY, AUX

      real elev, rlat, rlon, exlen, eylen, longorigin, utmn, utme


	real degr, minut



      integer narg, getnarg, i, j, lboxnum, magnum

      integer imark, npt, nptw, imarks(2), imarkold, seq_rec, ibuf



      integer l, lnblnk

      

      real dat(16), delta, totn, datv(16)

      real databuf(60,16)

      real magfac, fstime, decl

      real sc(16), cal(5)

      real calibs(5), cutsl(5), cutsh(5)

      real baseline(3)



      integer ind, daterr, nmax, tlen

      integer yy, mm, dd, hh, min, ss, dday, dhour, dmin, dss, tsec

      integer nent, nchan

      integer prterr, icall

      integer lbox

      integer byy,  bmm,  bdd,  bhh,  bmin,  bss, inc

      integer tdiff

c

      integer azimex, azimey, azimhx, ielev, idec

      integer baseln(3)

      integer*2 intgr(29)

c

      integer itgain, lenex, leney, mapcmp(16), gain(16)

      integer isamp, drop(5), ndrop



      character*11 lat, lon



      character*20 cmdarg

      character title*20, fout*40, indat*40, line*80, magline*120

      character proj*3, sep*1 

      character*40 outfile(2)

      character*7 cfile

      character*2 comp(16)

      character window*8, stat*6

      character*19 stime, etime, eetime, nowtim

      character*1 mt

      character prjcod*3, runnum*7, sitdes*20, latdir*1, lngdir*1

      character azdir*17, smpin1*4, smpin2*4





	character acqver*5, char1*2, char2*2


	integer ichar1, ichar2




      character*24 date_string



      real smprt1, smprt2

      integer*2 filtp1, filtp2





	logical DROPPOINTS



      common /scales/ sc

      common /contst/ inc, delta, prterr, nchan

      common /blkst/  byy,  bmm,  bdd,  bhh,  bmin,  bss

      common /header/ prjcod,runnum,sitdes,latdir,lngdir,azdir,

     >                smpin1,smpin2

      common /headr2/ smprt1, smprt2, baseln, intgr, filtp1, filtp2

      common /event/  title

      common /iflag/ icall, cal

      common /calbtn/ itgain, lenex, leney, magfac, gain, lbox, comp,

     >                mapcmp, cfile





      external date





c-------------------------------------------------------------------------------

c     initialize



      call chkend(sysend)

      call fdate(date_string)






c-------------------------------------------------------------------------------



c     Initialize variables and arrays.



      call dirsep(sep)

      ind  = 4

      inc  = 2

      magfac=10000.

      

c...code for SUN use  

      if( UNIX ) then    

        narg = getnarg()

        do i = 1, narg

          call getcmdarg( i, cmdarg)

          if( index(cmdarg,'h').ne.0 ) then

            write(*,*)'Permitted options:-'

            write(*,*)'                    -1  or -2  iprint level'

            stop

          else

            read(cmdarg,'(i2)') iprint

          endif

        enddo

      endif



109   call iin( 'Give print level (-1/0/1/2/3)',iprint)

      prterr  = iprint



110   continue



      if( iprint.ge.1 ) then

	  write(*,*) 'Program start at: ', date_string

	  write(*,*) 'Machine endian  : ', sysend

	  write(*,*) 'UNIX setting    : ', UNIX

	endif





c...request LiMS acquisition code version number (not in header!)


	acqver = '9.11'


	call tin('Give LiMS acquisition code version number', acqver )


	char1 = acqver(1:index(acqver,'.')-1)


	char2 = acqver(index(acqver,'.')+1:lnblnk(acqver))


	read(char1,*) ichar1


	read(char2,*) ichar2


	if( ichar1.ge.9 .and. ichar2.ge.11 ) then


	  DROPPOINTS = .FALSE.


	else


	  DROPPOINTS = .TRUE.


	endif





c-------------------------------------------------------------------------------


c     Set drop points to account for filter settling on data from LiMS


c     acquisition versions below 9.11


c     For sampling rate of "5", i.e. 30 s, must also add 25 s to start time





      if( DROPPOINTS ) then


c...12 Hz data: isamp = 1


        drop(1) = 17


c... 4 Hz data: isamp = 2


        drop(2) = 19


c... 1 Hz data: isamp = 3


        drop(3) = 22


c... 5 s  data: isamp = 4


        drop(4) = 20


c...30 s  data: isamp = 5


        drop(5) = 19


	else


	  drop(1) = 0


	  drop(2) = 0


	  drop(3) = 0


        drop(4) = 0


	  drop(5) = 0


	endif


	        

c-------------------------------------------------------------------------------



      if( iprint.ge.1 ) then

        write(*,*)' '

        write(*,*)' >>>>>>>>>>>>>>> MP2TS <<<<<<<<<<<<<<<<<<<'

        write(*,*)' '

        write(*,*)'           version = ', ver

        write(*,*)'build date = ', bdate

        write(*,*)' '

        write(*,*)' It is assumed that this program is being run from'

        write(*,*)' the database directory of the project '

        write(*,*)' (e.g. /local/mt/lims/nod)  '

        write(*,*)' and that all data files reside in subdirectories'

        write(*,*)' with the respective station names '

        write(*,*)' (e.g. /local/mt/lims/nod/nod001 nod002 etc.)'

        write(*,*)' '

        write(*,*)' windows and hardware database files are required'

        write(*,*)' (e.g. windows.nod & hardware.nod) '

        write(*,*)' '

      endif



c-------------------------------------------------------------------------------





      VERIFY = .FALSE.

      call lin( 'Verify data write?', VERIFY )



c-------------------------------------------------------------------------------

c

c  Read in the name of the input data file 



300   window = 'sno101a1'



      call tin( 'Give window (no extension)', window )

      title = window

      stat = window(1:6)

      if( iprint.ge.1 ) write(*,*)'Station =>', stat

      indat = stat//sep//window//'.1mp'

      proj = indat(1:3)

      title(1:12) = indat



      if( iprint.ge.1 ) then

        write(*,*)'Data file to open ==>', indat


	  call pause( 'Continue' )


      endif

c

c Open the data file and read in the window and header file information.

c

      byy = 9999

      imark=imarks(1)



      call rdhead(ind,indat,imark,*310)



      if( iprint.ge.1 ) then

        write(*,'(a)')'Header read in...'

        write(*,*)'prjcod =', prjcod

        write(*,*)'runnum =', runnum

        write(*,*)'sitdes =', sitdes

        write(*,*)'latdir =', latdir

        write(*,*)'lngdir =', lngdir

        write(*,*)'azdir  =', azdir

        write(*,*)'smpin1 =', smpin1

        write(*,*)'smpin2 =', smpin2

        write(*,*)'smprt1 =', smprt1

        write(*,*)'smprt2 =', smprt2

        write(*,*)'baseln =', baseln

        write(*,*)'filtp1 =', filtp1

        write(*,*)'filtp2 =', filtp2

        write(*,*)'nchan  =', nchan

        write(*,*)'delta  =', delta

        write(*,*)'byy    =', byy

        write(*,*)'bmm    =', bmm

        write(*,*)'bdd    =', bdd

        write(*,*)'bmin   =', bmin

        write(*,*)'bss    =', bss

      endif



c...add 1900 to byy -----------------------***THIS IS NOT Y2K COMPLIANT***

c      byy = 1900 + byy

c...end



c...determine sampling rate integer

      if( smpin1(1:2).eq.'hz' .or. smpin1(1:2).eq.'Hz') then

        if( smprt1.eq.12. ) then

          isamp = 1

        elseif( smprt1.eq.4. ) then

          isamp = 2

        elseif( smprt1.eq.1. ) then

          isamp = 3

        else

          write(*,*)'Unknown "Hz" sampling rate: smprt1 =', smprt1

          stop

        endif

      elseif( smpin1(1:3).eq.'sec' ) then

        if( smprt1.eq.1.) then

          isamp = 3

        elseif( smprt1.eq.5.) then

          isamp = 4

        elseif( smprt1.eq.30. ) then

          isamp = 5

        else

          write(*,*)'Unknown "sec" sampling rate: smprt1 =', smprt1

          stop

        endif

      else

        write(*,*)'Unknown sampling type =', smpin1

        stop

      endif

      ndrop = drop(isamp)

      if( iprint.ge.1 ) then

        write(*,*)'No of points to drop =', ndrop

      endif



      imarks(1)=imark

      azimex = intgr(12)

      azimey = intgr(13)

      azimhx = intgr(14)



      exlen = intgr(2)

      eylen = intgr(3)



      lboxnum = intgr(15)

      magnum  = intgr(16)



c...convert baselines from LiMS units to nT

      do i = 1, 3

        baseline(i) = 2.56 * float(baseln(i))

      enddo



      write( lat(1:3), '(i3.3)') intgr(4)

      lat(4:4) = ':'

      write( lat(5:6), '(i2.2)') intgr(5)

      lat(7:7) = ':'

      write( lat(8:9), '(i2.2)') intgr(6)

      lat(10:11) = ' '//latdir

      rlat = intgr(4) + intgr(5)/60. + intgr(6)/3600.

      if( latdir.eq.'S' ) rlat = -rlat



      write( lon(1:3), '(i3.3)') intgr(7)

      lon(4:4) = ':'

      write( lon(5:6), '(i2.2)') intgr(8)

      lon(7:7) = ':'

      write( lon(8:9), '(i2.2)') intgr(9)

      lon(10:11) = ' '//lngdir

      rlon = intgr(7) + intgr(8)/60. + intgr(9)/3600.

      if( lngdir.eq.'W' ) rlon = -rlon



      if( iprint.ge.1 ) then

        write(*,*)'Latitude  =', rlat

        write(*,*)'Longitude =', rlon

      endif

      

c...get UTM coordinates

      longorigin = 999.

      call geo2utm( rlat, rlon, longorigin, utmn, utme )

      if( iprint.ge.1 ) then

        write(*,*)'UTM-North =', utmn

        write(*,*)'UTM-East  =', utme

      endif



c...ask if want binary or ascii output and open files

10    type = 'u'

      call tin('FORMATTED ascii (f), or '//

     &         'UNFORMATTED binary (u) output?', type)

      outfile(1) = stat//sep//window//'.ts'

      outfile(2) = stat//sep//window//'.aux'



      if( type.eq.'f' ) then

        seq_rec = 1

        FORMATTED = .TRUE.

        form = 'FREE'

        call tin( 'Give format (include brackets)', form )

        write(*,*)'Opened formatted output file ', outfile(1)

        write(*,*)'Opened formatted aux    file ', outfile(2)

        open(10,file=outfile(1),status='unknown', form='formatted')

        open(11,file=outfile(2),status='unknown', form='formatted')

      else if( type.eq.'u' ) then

305     seq_rec = 1

        call iin('Give no. of sequences/record', seq_rec )

        if( seq_rec.gt.60 ) then

          write(*,'(a)')'seq_rec cannot be larger than 60'

          goto 305

        endif

        FORMATTED = .FALSE.



	  if( UNIX .and. sysend.eq.'Big' ) then

          open(10,file=outfile(1),status='unknown',form='unformatted')

          open(11,file=outfile(2),status='unknown',form='unformatted')

          write(*,'(a)')'Opened unformatted output file: '//outfile(1)

          write(*,'(a)')'Opened unformatted aux    file: '//outfile(2)

c...open DOS files as BIG_ENDIAN files to get big endian binary format

        else

#ifdef DOS

          open(10,file=outfile(1),status='unknown',form='unformatted',

     &         convert='BIG_ENDIAN')

          open(11,file=outfile(2),status='unknown',form='unformatted',

     &         convert='BIG_ENDIAN')

          write(*,'(a)')'Opened BIG_ENDIAN unformatted output file: '//

     &                   outfile(1)

          write(*,'(a)')'Opened BIG_ENDIAN unformatted aux    file: '//

     &                   outfile(2)

#else

          write(*,*)'Opening LITTLE ENDIAN ts files'

          open(10,file=outfile(1),status='unknown',form='unformatted')

          open(11,file=outfile(2),status='unknown',form='unformatted')

          write(*,'(a)')'Opened unformatted output file: '//outfile(1)

          write(*,'(a)')'Opened unformatted aux    file: '//outfile(2)

#endif

	  endif

      else

        write(*,*)'Unknown output type requested >',type,'< '//

     &            'please re-enter'

        goto 10

      endif



c

c  Initialize the required event start time with start time of data block.

c

      bss = 0

      call date( 1, stime, byy, bmm, bdd, bhh, bmin, bss )

      if( iprint.ge.2 ) write(*,*) 'block start time=',stime

      fstime = float(byy) +float(bmm)/12. +float(bdd)/(12.*30.)

      go to 320



310   write (*,*)' Error opening DATA INPUT file, re-enter.'

      go to 300



320   continue





c...open the hardware file for the project and get calib and filter values

c

      fout = 'hardware.'//proj

505   open ( inc, file=fout, status='old', form='formatted', err=510)

      if(iprint.ge.1) write(*,'(a)')'Opened project hardware file ='//

     &                fout

      call gethardware( inc, lboxnum, nchan, calibs, cutsl, cutsh )

c...DON'T close hardware file as its called again in input1d



      goto 520      

510   write (*,'(a)')'Error opening HARDWARE file - default values used'

      do i = 1, 5

        calibs(i) = 1.0

        cutsl(i)  = 0.2

        cutsh(i)  = 0.0

      enddo

      cutsh(3) = 30000.

      cutsh(4) = 30000.

520   continue



c...open site flat file ( "prj"site.flt ) and get elevation and declination

      fout = proj//'site.flt'

      open( unit=1, file=fout, status='old', err=550 )

      if(iprint.ge.1) write(*,'(a)')'Opened project site file ='//

     &                fout

c...find station entry

      read(1,'(a)') line

      do while( line(1:3).ne.stat(4:6) )

        read(1,'(a)',err=560) line

      enddo

      if(iprint.ge.1) then

        write(*,'(a)')'Found site in project file'

        write(*,'(a)')'line>',line(1:lnblnk(line))

      endif

      read(line(72:75),*,err=570) ielev

      read(line(77:79),*,err=575) idec

      elev = float(ielev)

      goto 580

550   write(*,*)'Project site file not found: ', fout(1:11)

      goto 570

560   write(*,*)'Site not found in project site file: ', fout(1:11)

570   write(*,'(a)')'Elevation incorrect in ts file'

      elev = 0.

575   write(*,*)'Declination will be calculated or entered by user'

      idec = 0

580   close(unit=1)



      if( nchan.eq.3 ) then

        if( mt.eq.'M' ) then

          write(*,*)'Only 3 channels found: GDS processing to be',

     &              ' undertaken'

          mt = 'G'

        endif

      else if( nchan.eq.5 ) then

        if( iprint.ge.1 ) write(*,*)'5 channels found'

      else

        write(*,*)'Wierd number of channels; not 3 or 5 -- ',

     &            'don''''t know what to do now!'

        stop

      endif

c

c---nchan = total number of channels recorded on the data file.

c   delta is the sampling rate in Hz

c

      if( iprint.ge.1 ) then

        write(*,*) 'Sampling rate in Hz =', delta 

      end if



900   if( iprint.ge.0 ) then

        write(*,'(a)') 'Give required start time           >'//

     &            'yyyy-mm-dd hh:mm:ss'

      end if

      call tin ( ' ', stime )

      call date( 0, stime, yy, mm, dd, hh, min, ss )

      if( iprint.ge.3 ) then

        write(*,*)' stime=',stime

        write(*,*)' yy, mm, dd, hh, min, ss =>', yy, mm, dd, hh, min, ss

      end if



      call chkdat( yy, mm, dd, hh, min, ss, daterr )

      if( daterr .gt. 0 ) go to 900



      if ( yy .ne. byy ) then

        write(*,'(a, i4)')' Requested wrong year!  Data block year is',

     &                      byy

        go to 900

      end if



901   if( iprint.ge.0 ) then

        write(*,'(a)') 'This end time is a GUESS (end of year) !!!'

        write(*,'(a)') 'Data only converted to the end time you enter'

        write(*,'(a)') 'Give desired end time              >'//

     &            'yyyy-mm-dd hh:mm:ss'

      endif

c...set end time to last day of year

      etime = '2000-12-31 23:59:59'


	etime(1:4) = stime(1:4)

      call tin ( ' ', etime )

      call date( 0, etime, yy, mm, dd, hh, min, ss )

      call date( 1, etime, yy, mm, dd, hh, min, ss )

      if( iprint.ge.3 ) then

        write(*,*)' etime=',etime

        write(*,*)' yy, mm, dd, hh, min, ss =>', yy, mm, dd, hh, min, ss

      end if



      call chkdat( yy, mm, dd, hh, min, ss, daterr )

      if( daterr .gt. 0 ) go to 901





c...call date again to get start time into variables "yy", "mm", etc.

      call date( 0, stime, yy, mm, dd, hh, min, ss )





c...calculate the total number of seconds of data to be reformatted

      tsec = tdiff( stime, etime )

      totn = float(tsec) * delta 

      nmax = nint(totn)



      if( iprint.ge.1 ) then 

        write(*,*) 'Total length in seconds       :', tsec

        write(*,*) 'Total number of data requested:', nmax

      end if



      dday  =  tsec / (24*60*60)

      dhour = (tsec - dday*24*60*60 ) / (60*60)

      dmin  = (tsec - dday*24*60*60 - dhour*60*60 ) / 60

      dss   =  tsec - dday*24*60*60 - dhour*60*60 - dmin*60



      if( iprint.ge.1 ) then

        write(*,'(a,4i2.2)') ' Event duration (ddhhmmss) >', 

     &                       dday, dhour, dmin, dss

      endif

 

c-------------------------------------------------------------------------------

c     write out comment block



      if( FORMATTED ) then

        write(10,'(a)')   '# time series file from mp2ts'

        write(10,'(2a)')  '# date: ', date_string

        write(10,'(a)')   '#'        

        write(10,'(2a)')  '# machine endian: ', sysend

        write(10,'(a,l)') '# UNIX set      : ', UNIX

        write(10,'(a)')   '#'

        write(10,'(2a)')  '# input file: ',indat

        write(10,'(a)')   '#'

        write(10,'(2a)')  '# site description: ',sitdes

        write(10,'(a)')   '#'

        write(10,'(2a)')  '# Latitude   :',lat

        write(10,'(2a)')  '# Longitude  :',lon

        write(10,'(a)')   '#'

        write(10,'(a,a)') '# LiMS acquisition code : ', acqver


	  write(10,'(a,i4)') '# LiMS box     number  : ', lboxnum

        write(10,'(a,i4)') '# Magnetometer number  : ', magnum

        write(10,'(a)')   '#'

        write(10,'(a,f10.2)') '# Ex line length: ', exlen

        write(10,'(a,f10.2)') '# Ey line length: ', eylen

        write(10,'(a)')   '#'

        write(10,'(2a)')  '# Azimuths relative to: '//azdir

        write(10,'(a,i3)') '# Ex azimuth; ', azimex

        write(10,'(a,i3)') '# Ey azimuth; ', azimey

        write(10,'(a,i3)') '# Hx azimuth; ', azimhx

        write(10,'(a,i3)') '# Hy azimuth; ', azimhx+90

        write(10,'(a)')   '#'

        write(10,'(a,i2,a)') '# FIRST ',ndrop,' POINTS DROPPED '//

     &                      'FROM .1mp FILE TO '

        write(10,'(a)')   '# ACCOUNT FOR FILTER SETTLING'

        write(10,'(a)')   '#'



        write(11,'(a)')  '# auxiliary time series file from mp2ts'

        write(11,'(2a)') '# date: ', date_string

        write(11,'(a)')  '#'

        write(11,'(2a)') '# machine endian: ', sysend

        write(11,'(a,l)') '# UNIX set      : ', UNIX

        write(11,'(a)')  '#'

        write(11,'(2a)') '# input file =',indat

        write(11,'(a)')  '#'

        write(11,'(2a)') '# site description: ',sitdes

        write(11,'(a)')  '#'

        write(11,'(2a)') '# Latitude   :',lat

        write(11,'(2a)') '# Longitude  :',lon

        write(11,'(a)')  '#'

        write(11,'(a,i4)') '# LiMS         number : ', lboxnum

        write(11,'(a)')  '#'

        write(11,'(a)')  '# Channel 1: LiMS internal temperature'

        write(11,'(a)')  '# Channel 2: Magnetometer temperature'

        write(11,'(a)')  '# Channel 3: Battery voltage'

        write(11,'(a)')  '#'


	  if( DROPPOINTS ) then

          write(11,'(a,i2,a)')   '# FIRST ',ndrop,' POINTS DROPPED '//

     &                      'FROM .1mp FILE TO ACCOUNT FOR FILTER'//

     &                      ' SETTLING'

          write(11,'(a)')   '#'


	  endif





      else

        line = '# time series file from mp2ts'

        write(10) line

        line = '# auxiliary time series file from mp2ts'

        write(11) line

        line = '# date: '//date_string

        write(10) line

        write(11) line



        line = '#'

        write(10) line

        write(11) line

        line = '# input file: '//indat

        write(10) line

        write(11) line



        line = '#'

        write(10) line

        write(11) line

        line = '# Machine endian: '//sysend

        write(10) line

        write(11) line

        line = '# UNIX set      : '

        write(line(19:19),'(l1)') UNIX

        write(10) line

        write(11) line



        line = '#'

        write(10) line

        write(11) line

        line = '# site description: '//sitdes

        write(10) line

        write(11) line



        line = '#'

        write(10) line

        write(11) line

        line = '# Latitude   :'//lat

        write(10) line

        write(11) line

        line = '# Longitude  :'//lon

        write(10) line

        write(11) line



c...instrument numbers

        line = '#'

        write(10) line

        write(11) line

        write(line,'(a,a)') '# LiMS acquisition code : ', acqver

        write(10) line

        write(11) line

        write(line,'(a,i4)') '# LiMS box     number   : ', lboxnum


        write(10) line


        write(11) line


	  write(line,'(a,i4)') '# Magnetometer number   : ', magnum

        write(10) line



        line = '#'

        write(10) line

        write(line,'(a,f10.2)') '# Ex line length (m): ', exlen

        write(10) line

        write(line,'(a,f10.2)') '# Ey line length (m): ', eylen

        write(10) line



        line = '#'

        write(10) line

        line = '# Azimuths relative to: '//azdir

        write(10) line

        write(line,'(a,i3)') '# Ex azimuth; ', azimex

        write(10) line

        write(line,'(a,i3)') '# Ey azimuth; ', azimey

        write(10) line

        write(line,'(a,i3)') '# Hx azimuth; ', azimhx

        write(10) line

        write(line,'(a,i3)') '# Hy azimuth; ', azimhx+90

        write(10) line



        line = '#'

        write(11) line

        line = '# Channel 1: LiMS internal temperature'

        write(11) line

        line = '# Channel 2: Magnetometer temperature'

        write(11) line

        line = '# Channel 3: Battery voltage'

        write(11) line




	  if( DROPPOINTS ) then

          line = '#'

          write(10) line

          write(11) line

          line = '# FIRST xx POINTS DROPPED FROM .1mp FILE TO'

          write(line(9:10),'(i2)') ndrop

          write(10) line

          write(11) line

          line = '# ACCOUNT FOR FILTER SETTLING'

          write(10) line

          write(11) line

          line = '#'

          write(10) line

          write(11) line


	  endif




      endif



c-------------------------------------------------------------------------------

c     write out filter block



      if( FORMATTED ) then

        write(10,'(a)') '#F Filter block begin'

        write(10,'(a)') '#F'

        write(10,'(a)') '#F Filters applied to LiMS/LRMT data are:'

        write(10,'(a)') '#F 1: Analogue anti-alias six-pole Bessel '//

     &                         'low-pass'

        write(10,'(a)') '#F    filters on each channel with -3 dB '//

     &                'point at nominally 5 Hz.'

        write(10,'(a)') '#F    -calibrated values given below'

        write(10) line

        write(10,'(a)') '#F'

        write(10,'(a)') '#F 2: Digital anti-alias multi-stage '//

     &                'Chebyshev FIR filters'

        write(10,'(a)') '#F    with final stage at 2xsampling rate'

        write(10,'(a)') '#F'

        write(10,'(a)') '#F 1: Analogue single-pole Butterworth '//

     &               'high-pass filters on the'

        write(10,'(a)') '#F    telluric channels only with -3 dB '//

     &                'point at nominally 30,000 s'

        write(10,'(a)') '#F    -calibrated values given below'

        write(10,'(a)') '#F'

        write(10,'(a)') '#F Chan     Calib    Low-pass   High-pass (s)'

        if(nchan.eq.5)then

c...note reordering that takes place in main processing codes

          write(10,'(a,i2,3f12.2)')'#F ',1,calibs(1),cutsl(1),cutsh(1)

          write(10,'(a,i2,3f12.2)')'#F ',2,calibs(2),cutsl(2),cutsh(2)

          write(10,'(a,i2,3f12.2)')'#F ',3,calibs(5),cutsl(5),cutsh(5)

          write(10,'(a,i2,3f12.2)')'#F ',4,calibs(3),cutsl(3),cutsh(3)

          write(10,'(a,i2,3f12.2)')'#F ',5,calibs(4),cutsl(4),cutsh(4)

        else

          do i = 1, nchan

            write(10,'(a,i2,3f12.2)')'#F ',i,calibs(i),cutsl(i),cutsh(i)

          enddo

        endif

        write(10,'(a)') '#F'

        write(10,'(a)') '#F In the tsrestack code, these filter '//

     &                      'responses'

        write(10,'(a)') '#F are removed using bessel7.f and high17.f'

        write(10,'(a)') '#F'

        write(10,'(a)') '#F Filter block end'



      else

        line = '#F Filter block begin'

        write(10) line

        line = '#F'

        write(10) line

        line = '#F Filters applied to LiMS/LRMT data are:'

        write(10) line

        line = '#F 1: Analogue anti-alias six-pole Bessel low-pass'

        write(10) line

        line = '#F    filters on each channel with -3 dB point at '//

     &                'nominally 5 Hz.'

        write(10) line

        line = '#F    -calibrated values given below'

        write(10) line

        line = '#F'

        write(10) line

        line = '#F 2: Digital anti-alias multi-stage Chebyshev FIR '//

     &                'filters'

        write(10) line

        line = '#F    with final stage at 2xsampling rate'

        write(10) line

        line = '#F'

        write(10) line

        line = '#F 1: Analogue single-pole Butterworth high-pass '//

     &               'filters on the'

        write(10) line

        line = '#F    telluric channels only with -3 dB point at'//

     &                ' nominally 30,000 s'

        write(10) line

        line = '#F    -calibrated values given below'

        write(10) line

        line = '#F'

        write(10) line

        line = '#F Chan     Calib    Low-pass   High-pass (s)'

        write(10) line

        if(nchan.eq.5)then

c...note reordering that takes place in main processing codes

          write(line(4:),'(i2,3f12.2)')1, calibs(1), cutsl(1), cutsh(1)

          write(10) line

          write(line(4:),'(i2,3f12.2)')2, calibs(2), cutsl(2), cutsh(2)

          write(10) line

          write(line(4:),'(i2,3f12.2)')3, calibs(5), cutsl(5), cutsh(5)

          write(10) line

          write(line(4:),'(i2,3f12.2)')4, calibs(3), cutsl(3), cutsh(3)

          write(10) line

          write(line(4:),'(i2,3f12.2)')5, calibs(4), cutsl(4), cutsh(4)

          write(10) line

        else

          do i = 1, nchan

            write(line(4:),'(i2,3f12.2)')i,calibs(i),cutsl(i),cutsh(i)

            write(10) line

          enddo

        endif

        line = '#F'

        write(10) line

        line = '#F In the tsrestack code, these filter responses are'

        write(10) line

        line = '#F removed using bessel7.f and high17.f'

        write(10) line

        line = '#F'

        write(10) line

        line = '#F Filter block end'

        write(10) line

      endif





c-------------------------------------------------------------------------------

c     write out info block





c...info start

      line = '>INFO_START:'

      if( FORMATTED ) then

        write(10,'(a)') line

        write(11,'(a)') line

      else

        write(10) line

        write(11) line

      endif



c...station

      line = '>STATION'

      line(12:) = ':'

      line(13:) = stat

      if( FORMATTED ) then

        write(10,'(a)') line

        write(11,'(a)') line

      else

        write(10) line

        write(11) line

      endif



c...instrument

      line = '>INSTRUMENT'

      line(12:) = ':'

      write(line(13:),*) lboxnum

      if( FORMATTED ) then

        write(10,'(a)') line

        write(11,'(a)') line

      else

        write(10) line

        write(11) line

      endif



c...window

      line = '>WINDOW'

      line(12:) = ':'

      line(13:) = window

      if( FORMATTED ) then

        write(10,'(a)') line

        write(11,'(a)') line

      else

        write(10) line

        write(11) line

      endif



c...latitude

      line = '>LATITUDE'

      line(12:) = ':'

      write( line(13:),*) rlat

      if( FORMATTED ) then

        write(10,'(a)') line

        write(11,'(a)') line

      else

        write(10) line

        write(11) line

      endif



c...longitude

      line = '>LONGITUDE'

      line(12:) = ':'

      write( line(13:),*) rlon

      if( FORMATTED ) then

        write(10,'(a)') line

        write(11,'(a)') line

      else

        write(10) line

        write(11) line

      endif



c...elevation

      line = '>ELEVATION'

      line(12:) = ':'

      write( line(13:),* ) elev

      if( FORMATTED ) then

        write(10,'(a)') line

        write(11,'(a)') line

      else

        write(10) line

        write(11) line

      endif



c...UTM coordinates

      line = '>UTM_ORIGIN'

      line(12:) = ':'

      write( line(13:),* ) longorigin

      if( FORMATTED ) then

        write(10,'(a)') line

        write(11,'(a)') line

      else

        write(10) line

        write(11) line

      endif



      line = '>UTM_NORTH'

      line(12:) = ':'

      write( line(13:),* ) nint(utmn)

      if( FORMATTED ) then

        write(10,'(a)') line

        write(11,'(a)') line

      else

        write(10) line

        write(11) line

      endif



      line = '>UTM_EAST'

      line(12:) = ':'

      write( line(13:),* ) nint(utme)

      if( FORMATTED ) then

        write(10,'(a)') line

        write(11,'(a)') line

      else

        write(10) line

        write(11) line

      endif



c...coordinate system

      line = '>COORD_SYS'

      line(12:) = ':'

      line(13:) = azdir

      if( FORMATTED ) then

        write(10,'(a)') line

      else

        write(10) line

      endif



c...declination

      if( index(azdir,'MAGNETIC').ne.0 ) then

        if( UNIX ) then

c...the following code obtains the declination from a given lat & long

c   for DOS you must input it

c

c   change the following directory to the one where it will find the

c   "igrf" file on your system

c

          magline ='geomag31 /local/mt/lims/v5.0/src/geomagV31'//


     &             '/igrf'


	    l = lnblnk(magline)


		magline(l+1:) = ' '

          write(magline(l+2:),'(f6.1)') fstime


		l = lnblnk(magline)

          magline(l+1:) = ' D K'


	    l = lnblnk(magline)


	    write(magline(l+1:),'(f4.2)') elev/1000.


		l = lnblnk(magline)


	    magline(l+1:) = ' '

          write(magline(l+2:),'(f6.3)') rlat


	    l = lnblnk(magline)

          magline(l+1:) = ' '

          write(magline(l+2:),'(f8.3)') rlon


	    l = lnblnk(magline)

          magline(l+1:) = ' > mp2ts.dec'

          if( iprint.ge.1 ) then

            write(*,*)'Geomag line>', magline(1:lnblnk(magline))

          endif

          call system( magline )


c...the following finds the declination in file mp2ts.dec


          open(unit=ind2,file='mp2ts.dec')


680       continue


          read(ind2,'(a)') line


          if(line(6:10).ne.'(deg)') go to 680


c   now positioned on line before desired info, so read next line


          read(ind2,'(a)') line


c   read the degrees from the line


          read(line(3:5),'(i3)') i


          degr=float(i)


c   then read the minutes


          read(line(7:11),'(f5.1)')minut


c   convert to decimal degree


          decl=degr+minut/60.


          close(unit=ind2)

          write(*,'(a,f10.2)')'Declination calculated =', decl

          line = 'rm mp2ts.dec'

          call system( line )

        else

          decl=float(idec)

          call rin('Give declination [default is site value]', decl)

        endif

        

        line = '>DECLIN'

        line(12:) = ':'

        write(line(13:),*) decl

        if( FORMATTED ) then

          write(10,'(a)') line

        else

          write(10) line

        endif

      endif





c...form

      line = '>FORM'

      line(12:) = ':'

      if( FORMATTED ) then

        line(13:) = 'ASCII'

        write(10,'(a)') line

        write(11,'(a)') line

      else

        line(13:) = 'BINARY'

        write(10) line

        write(11) line

      endif



c...format

      line = '>FORMAT'

      line(12:) = ':'

      if( FORMATTED ) then

        line(13:) = form

        write(10,'(a)') line

        write(11,'(a)') line

      else

        line(13:) = 'UNFORMATTED'

        write(10) line

        write(11) line

      endif



c...endian

      line = '>ENDIAN'

      line(12:) = ':'

      if( FORMATTED ) then

        continue

      else

        line(13:) = 'Big'

        write(10) line

        write(11) line

      endif



c...binary format

      line = '>BIN_FORM'

      line(12:) = ':'

      if( FORMATTED ) then

        continue

      else

        line(13:) = 'IEEE'

        write(10) line

        write(11) line

      endif



c...seq_rec

      line = '>SEQ_REC'

      line(12:) = ':'

      write( line(13:),* ) seq_rec

      if( FORMATTED ) then

        write(10,'(a)') line

        write(11,'(a)') line

      else

        write(10) line

        write(11) line

      endif



c...nchan

      line = '>NCHAN'

      line(12:) = ':'

      write( line(13:),* ) nchan

      if( FORMATTED ) then

        write(10,'(a)') line

      else

        write(10) line

      endif

      write( line(13:),* ) 3

      if( FORMATTED ) then

        write(11,'(a)') line

      else

        write(11) line

      endif





c...Ti - instrument temperature

      line = '>CHAN_1'

      line(12:) = ':'

      line(13:) = 'Ti'

      if( FORMATTED ) then

        write(11,'(a)') line

      else

        write(11) line

      endif

c...units

      line = '>UNITS_1'

      line(12:) = ':'

      line(13:) = 'degC'

      if( FORMATTED ) then

        write(11,'(a)') line

      else

        write(11) line

      endif

c...gain

      line = '>GAIN_1'

      line(12:) = ':'

      line(13:) = '1.0'

      if( FORMATTED ) then

        write(11,'(a)') line

      else

        write(11) line

      endif





c...Th - head temperature

      line = '>CHAN_2'

      line(12:) = ':'

      line(13:) = 'Th'

      if( FORMATTED ) then

        write(11,'(a)') line

      else

        write(11) line

      endif

c...units

      line = '>UNITS_2'

      line(12:) = ':'

      line(13:) = 'degC'

      if( FORMATTED ) then

        write(11,'(a)') line

      else

        write(11) line

      endif

c...gain

      line = '>GAIN_2'

      line(12:) = ':'

      line(13:) = '1.0'

      if( FORMATTED ) then

        write(11,'(a)') line

      else

        write(11) line

      endif





c...Bt - external battery voltage

      line = '>CHAN_3'

      line(12:) = ':'

      line(13:) = 'Bt'

      if( FORMATTED ) then

        write(11,'(a)') line

      else

        write(11) line

      endif

c...units

      line = '>UNITS_3'

      line(12:) = ':'

      line(13:) = 'V'

      if( FORMATTED ) then

        write(11,'(a)') line

      else

        write(11) line

      endif

c...gain

      line = '>GAIN_3'

      line(12:) = ':'

      line(13:) = '1.0'

      if( FORMATTED ) then

        write(11,'(a)') line

      else

        write(11) line

      endif





c...chan_1

      line = '>CHAN_1'

      line(12:) = ':'

      line(13:) = 'HX'

      if( FORMATTED ) then

        write(10,'(a)') line

      else

        write(10) line

      endif

c...sensor_1

      line = '>SENSOR_1'

      line(12:) = ':'

      write( line(13:),* ) magnum

      if( FORMATTED ) then

        write(10,'(a)') line

      else

        write(10) line

      endif

c...baseline_1

      line = '>BASELINE_1'

      line(12:) = ':'

      write( line(13:),* ) baseline(1)

      if( FORMATTED ) then

        write(10,'(a)') line

      else

        write(10) line

      endif

c...azim_1

      line = '>AZIM_1'

      line(12:) = ':'

      write( line(13:),* ) float(azimhx)

      if( FORMATTED ) then

        write(10,'(a)') line

      else

        write(10) line

      endif

c...units_1

      line = '>UNITS_1'

      line(12:) = ':'

      line(13:) = 'nT'

      if( FORMATTED ) then

        write(10,'(a)') line

      else

        write(10) line

      endif

c...gain_1

      line = '>GAIN_1'

      line(12:) = ':'

      line(13:) = '1.0'

      if( FORMATTED ) then

        write(10,'(a)') line

      else

        write(10) line

      endif





c...chan_2

      line = '>CHAN_2'

      line(12:) = ':'

      line(13:) = 'HY'

      if( FORMATTED ) then

        write(10,'(a)') line

      else

        write(10) line

      endif

c...sensor_2

      line = '>SENSOR_2'

      line(12:) = ':'

      write( line(13:),* ) magnum

      if( FORMATTED ) then

        write(10,'(a)') line

      else

        write(10) line

      endif

c...baseline_2

      line = '>BASELINE_2'

      line(12:) = ':'

      write( line(13:),* ) baseline(2)

      if( FORMATTED ) then

        write(10,'(a)') line

      else

        write(10) line

      endif

c...azim_2

      line = '>AZIM_2'

      line(12:) = ':'

      write( line(13:),* ) float(azimhx + 90)

      if( FORMATTED ) then

        write(10,'(a)') line

      else

        write(10) line

      endif

c...units_2

      line = '>UNITS_2'

      line(12:) = ':'

      line(13:) = 'nT'

      if( FORMATTED ) then

        write(10,'(a)') line

      else

        write(10) line

      endif

c...gain_2

      line = '>GAIN_2'

      line(12:) = ':'

      line(13:) = '1.0'

      if( FORMATTED ) then

        write(10,'(a)') line

      else

        write(10) line

      endif





c...chan_3

      line = '>CHAN_3'

      line(12:) = ':'

      line(13:) = 'HZ'

      if( FORMATTED ) then

        write(10,'(a)') line

      else

        write(10) line

      endif

c...sensor_3

      line = '>SENSOR_3'

      line(12:) = ':'

      write( line(13:),* ) magnum

      if( FORMATTED ) then

        write(10,'(a)') line

      else

        write(10) line

      endif

c...baseline_3

      line = '>BASELINE_3'

      line(12:) = ':'

      write( line(13:),* ) baseline(3)

      if( FORMATTED ) then

        write(10,'(a)') line

      else

        write(10) line

      endif

c...azim_3

      line = '>AZIM_3'

      line(12:) = ':'

      write( line(13:),* ) 0.0

      if( FORMATTED ) then

        write(10,'(a)') line

      else

        write(10) line

      endif

c...units_3

      line = '>UNITS_3'

      line(12:) = ':'

      line(13:) = 'nT'

      if( FORMATTED ) then

        write(10,'(a)') line

      else

        write(10) line

      endif

c...gain_3

      line = '>GAIN_3'

      line(12:) = ':'

      line(13:) = '1.0'

      if( FORMATTED ) then

        write(10,'(a)') line

      else

        write(10) line

      endif





      if( nchan.eq.5) then

c...chan_4

      line = '>CHAN_4'

      line(12:) = ':'

      line(13:) = 'EX'

      if( FORMATTED ) then

        write(10,'(a)') line

      else

        write(10) line

      endif

c...sensor_4

      line = '>SENSOR_4'

      line(12:) = ':'

      write( line(13:),* ) lboxnum

      if( FORMATTED ) then

        write(10,'(a)') line

      else

        write(10) line

      endif

c...azim_4

      line = '>AZIM_4'

      line(12:) = ':'

      write( line(13:),* ) float(azimex)

      if( FORMATTED ) then

        write(10,'(a)') line

      else

        write(10) line

      endif

c...units_4

      line = '>UNITS_4'

      line(12:) = ':'

      line(13:) = 'mV/km'

      if( FORMATTED ) then

        write(10,'(a)') line

      else

        write(10) line

      endif

c...gain_4

      line = '>GAIN_4'

      line(12:) = ':'

      line(13:) = '1.0'

      if( FORMATTED ) then

        write(10,'(a)') line

      else

        write(10) line

      endif



c...chan_5

      line = '>CHAN_5'

      line(12:) = ':'

      line(13:) = 'EY'

      if( FORMATTED ) then

        write(10,'(a)') line

      else

        write(10) line

      endif

c...sensor_5

      line = '>SENSOR_5'

      line(12:) = ':'

      write( line(13:),* ) lboxnum

      if( FORMATTED ) then

        write(10,'(a)') line

      else

        write(10) line

      endif

c...azim_5

      line = '>AZIM_5'

      line(12:) = ':'

      write( line(13:),* ) float(azimey)

      if( FORMATTED ) then

        write(10,'(a)') line

      else

        write(10) line

      endif

c...units_5

      line = '>UNITS_5'

      line(12:) = ':'

      line(13:) = 'mV/km'

      if( FORMATTED ) then

        write(10,'(a)') line

      else

        write(10) line

      endif

c...gain_5

      line = '>GAIN_5'

      line(12:) = ':'

      line(13:) = '1.0'

      if( FORMATTED ) then

        write(10,'(a)') line

      else

        write(10) line

      endif



      endif





c...starttime

      line = '>STARTTIME'

      line(12:) = ':'

      if( isamp.eq.5 ) then

        line(13:) = stime//'25'

      else

        line(13:) = stime//'00'

      endif

      if( FORMATTED ) then

        write(10,'(a)') line

        write(11,'(a)') line

      else

        write(10) line

        write(11) line

      endif



c...endtime

      line = '>ENDTIME'

      line(12:) = ':'

      line(13:) = etime//'00'

      if( FORMATTED ) then

        write(10,'(a)') line

        write(11,'(a)') line

      else

        write(10) line

        write(11) line

      endif



c...tunits

      line = '>T_UNITS'

      line(12:) = ':'

      line(13:) = 's'

      if( FORMATTED ) then

        write(10,'(a)') line

        write(11,'(a)') line

      else

        write(10) line

        write(11) line

      endif



c...delta_t

      line = '>DELTA_T'

      line(12:) = ':'

      write( line(13:), * ) 1./delta

      if( FORMATTED ) then

        write(10,'(a)') line

      else

        write(10) line

      endif

      write( line(13:), * ) 600.

      if( FORMATTED ) then

        write(11,'(a)') line

      else

        write(11) line

      endif



c...misdat

      line = '>MIS_DATA'

      line(12:) = ':'

      write( line(13:), * ) DEFMISDAT

      if( FORMATTED ) then

        write(10,'(a)') line

        write(11,'(a)') line

      else

        write(10) line

        write(11) line

      endif





c...info end

      line = '>INFO_END  :'

      if( FORMATTED ) then

        write(10,'(a)') line

        write(11,'(a)') line

      else

        write(10) line

        write(11) line

      endif









c...data reading loop...........................................................




      if( DROPPOINTS ) then

        write(*,*)' '

        write(*,*)'DROPPING FIRST',ndrop,'  DATA POINTS'

        write(*,*)' '


	endif

      npt = 0

      nptw = 1

    7 CONTINUE



c...read in data from local site 

      imarkold=imarks(1)



      call input1d(ind,lboxnum,dat,nent,yy,mm,dd,hh,min,ss,tsec,imark)

      npt = npt+1



c...drop first "ndrop" data points !!!!!

      if( npt.le.ndrop ) goto 7



      ibuf = mod( npt, seq_rec )

      if( ibuf.eq.0 ) ibuf = seq_rec



c...data end found when nent = -1      

      if( nent.lt.0 ) goto 120

      

      if( imark.ne.imarkold ) then

        imarkold = imark

        AUX = .TRUE.

        if( iprint.ge.3 ) then

          write(*,*) 'Ti, Th & battery ',

     &                 dat(nchan+4), dat(nchan+5), dat(nchan+6)

        endif

      else

        AUX = .FALSE.

      endif



      imarks(1)=imark

      if( iprint.ge.3 ) then

        write(*,*) 'Input dat =>', (dat(i),i=1,nchan)

      end if



      do i = 1, nchan

        databuf(ibuf,i) = dat(i)

      enddo

      do i = nchan+4, nchan+6

        databuf(ibuf,i) = dat(i)

      enddo



c...get more data into buffer

      if( ibuf.ne.seq_rec .and. npt.lt.nmax ) goto 7



c...write data  out



      nptw = nptw + 1



      if( FORMATTED ) then

        if( form.eq.'FREE' ) then

          write(10,*) (dat(i),i=1,nchan)

        else

          write(10,form) (dat(i),i=1,nchan)

        endif

      else

        write(10) ((databuf(j,i),i=1,nchan),j=1,seq_rec)

      endif



      if( AUX ) then

        if( FORMATTED ) then

          if( form.eq.'FREE' ) then

            write(11,*) (dat(nchan+i),i=4,6)

          else

            write(11,form) (dat(nchan+i),i=4,6)

          endif

        else

          write(11) ((databuf(j,nchan+i),i=4,6),j=1,seq_rec)

        endif

      endif



      if( VERIFY ) then

        backspace(unit=10)

        if( FORMATTED ) then

          if( form.eq.'FREE' ) then

            read(10,*) (datv(i),i=1,nchan)

          else

            read(10,form) (datv(i),i=1,nchan)

          endif

        else

          read(10) (datv(i),i=1,nchan)

        endif



        do j = 1, nchan

          if( dat(j).ne.datv(j) ) then

            write(*,*)'Verification error !!!!!   npt =',npt

            write(*,*)'dat   :', (dat (i),i=1,nchan)

            write(*,*)'datv  :', (datv(i),i=1,nchan)

            goto 100

          endif

        enddo

      endif



c...get more data or wrap up

100   if( npt.lt.nmax ) goto 7



120   write(*,'(a,i10)')'Number of points written: ', nptw

      tlen = nint( float(nptw-1) / delta )

      eetime = nowtim( stime, 0, 0, 0, tlen )

      if( iprint.ge.1 ) then

        write(*,'(a,i10)')'Actual length in seconds = ', tlen

        write(*,'(2a)')'Actual end time = ', eetime

      endif

      if( eetime.ne.etime ) then

        write(*,'(2a)')'Number of points LESS than expected: '//

     &                 'end time =',eetime

        write(*,'(a)')'ENDTIME in ts file is incorrect'

      endif



c

c--Write start and end times into windows file

c

      fout = 'windows.'//proj

  405 open( inc, file=fout, status='old', form='formatted', err=406 )

      if( iprint.ge.0 ) then

        write(*,'(4a)')'Opened old project windows.',proj,' file to ',

     &                  'add window info:'

        write(*,'(a8,1x,i3.3,1x,i1,1x,a19,a1,a19,1x,f9.6)')

     &            window, lboxnum, nchan, stime, '-', eetime, delta

      endif

c...read to end of windows file      

      do while( .TRUE. )

        read( inc,*,end=407 )

      enddo

      write(*,*)'Should never get this message !!!'

  406 open( inc, file=fout, status='new', form='formatted', err=9999 )      

      if( iprint.ge.0 ) then

        write(*,'(3a)')'Opened new project windows.',proj,

     &                  ' file to add window info:'

        write(*,'(a8,1x,i3.3,1x,i1,1x,a19,a1,a19,1x,f9.6)')

     &            window, lboxnum, nchan, stime, '-', eetime, delta

      endif

  407 write(inc,'(a8,1x,i3.3,1x,i1,1x,a19,a1,a19,1x,f9.6)')

     &            window, lboxnum, nchan, stime, '-', eetime, delta

      close(unit=inc) 



      stop

      

9999  stop 'Error writing window information to windows file....'

      end





