#!/bin/csh -f
#
#script to test whether date1 > date2 (status 0)
#                       date1 < date2 (status 1)
#
# date format (19 chars): yyyy-mm-dd hh:mm:ss
#

set part1 = `echo $1`
set part2 = `echo $2`
set part3 = `echo $3`
set part4 = `echo $4`

set date1 = `echo $part1' '$part2`

set date2 = `echo $part3' '$part4`


#...convert dates to numbers for comparison purposes
set yy1 = `echo $date1 | cut -c1-4`
set mm1 = `echo $date1 | cut -c6-7`
set dd1 = `echo $date1 | cut -c9-10`
set hh1 = `echo $date1 | cut -c12-13`
set mn1 = `echo $date1 | cut -c15-16`
set ss1 = `echo $date1 | cut -c18-19`

set yy2 = `echo $date2 | cut -c1-4`
set mm2 = `echo $date2 | cut -c6-7`
set dd2 = `echo $date2 | cut -c9-10`
set hh2 = `echo $date2 | cut -c12-13`
set mn2 = `echo $date2 | cut -c15-16`
set ss2 = `echo $date2 | cut -c18-19`

#test if dates are the same. If so then return
if ( $yy1$mm1$dd1$hh1$mn1$ss1 == $yy2$mm2$dd2$hh2$mn2$ss2 ) then
  exit(0)
endif

#...test years, if same then test months
if ( $yy1 > $yy2 ) then
  exit(0)
else if ( $yy1 < $yy2 ) then
  exit(1)
endif

#...test months, if same then test days
if ( $mm1 > $mm2 ) then
  exit(0)
else if ( $mm1 < $mm2 ) then
  exit(1)
endif

#...test days, if same then test hours
if ( $dd1 > $dd2 ) then
  exit(0)
else if ( $dd1 < $dd2 ) then
  exit(1)
endif

#...test hours, if same then test minutes
if ( $hh1 > $hh2 ) then
  exit(0)
else if ( $hh1 < $hh2 ) then
  exit(1)
endif

#...test minutes, if same then test seconds
if ( $mn1 > $mn2 ) then
  exit(0)
else if ( $mn1 < $mn2 ) then
  exit(1)
endif

#...test seconds, if same then error return 0
if ( $ss1 > $ss2 ) then
  exit(0)
else if ( $ss1 < $ss2 ) then
  exit(1)
endif

echo 'Dates are equal - but shouldn't get this message'
exit(0)
