#!/bin/csh  -f
#
#  lims_dcmp
#
#  sets up files for dcmp script
#

onintr exit

set old=$cwd

start:
set root = ` `

set stn      = `cat .lims.stn`
set dbase    = `cat .lims.dbase`
set stn_dir  = `cat .lims.stn_dir`
set lims_dir = `cat .lims.lims_dir`

cd $stn_dir

echo $dbase > .lims.dbase

  echo  ' ' 
  echo  '  RESPONSE AND G-B FILES FOUND IN: '$stn_dir
  echo  ' '
  ls *.dat *.g? 

  if( -e $stn'r.dat' || -e $stn'cr.dat' ) set r = r
  if( -e $stn'l.dat' || -e $stn'cl.dat' ) set r = l

  if( ( -e $stn'r.dat' || -e $stn'cr.dat' ) && ( -e $stn'l.dat' || -e $stn'cl.dat' ) ) then
    echo ' '
    echo 'Both local & remote response files found ... plot local or remote ?'
response_select:
    echo -n 'Response (l/r) =>'$root
    set r=$<
    if( $r != 'r'  &&  $r != 'l' ) then
      echo 'Incorrect response -- re-enter'
      goto response_select
    endif
  endif

  set j = 'j'
  if ( -e $stn$r'.dat' && -e $stn'c'$r'.dat' ) then
    echo ' '
    echo 'Both jones & chave response files found ... plot jones or chave ?'
chave_select:
    echo -n 'Response (j/c) =>'$root
    set j=$<
    if ( $j != 'j' &&  $j != 'c' &&  $j != 'b' ) then
      echo 'Incorrect response -- re-enter'
      goto response_select
    endif
  endif

#-check existence of a .dat file

  if( -e $stn'.dat' ) mv $stn'.dat' 'tmp.dat'
  if( -e $stn'.g'   ) mv $stn'.g'   'tmp.g'
  if( -e $stn'.grm' ) mv $stn'.grm' 'tmp.grm'

#-change names of data, g & grm files


  if ( $j == 'c' ) then
    cp $stn_dir/$stn'c'$r'.dat' $stn'.dat'
  else
    cp $stn_dir/$stn$r'.dat'    $stn'.dat'
  endif
  if( -e $stn$r'.g'   ) mv $stn$r'.g'   $stn'.g'
  if( -e $stn$r'.grm' ) mv $stn$r'.grm' $stn'.grm'

#-check age of .dat cf. .g & .grm; remove .g * .grm if younger than .dat

  older $stn'.dat' $stn'.g'
  if( $status == 0 ) then 
    rm $stn'.g'
    echo '..........removing older .g file'
  endif

  older $stn'.dat' $stn'.grm'
  if( $status == 0 ) then
    rm $stn'.grm'
    echo '..........removing older .grm file'
  endif


#-run dcmp

  set stn_num =  `echo $stn | sed 's/'$dbase'//'`

  dcmp loc $stn_num


 
exit:
  rm $stn'.dat'
  mv $stn'.g'    $stn$r'.g'
  if( -e $stn'.grm' ) mv $stn'.grm'  $stn$r'.grm'
  if( -e 'tmp.dat' )  mv 'tmp.dat' $stn'.dat'
  if( -e 'tmp.g'   )  mv 'tmp.g'   $stn'.g'
  if( -e 'tmp.grm' )  mv 'tmp.grm' $stn'.grm'
  cd $old

