#!/bin/csh  -f
#
#  lims_mtc
#
#  plots data from a station
#

onintr exit

set old=$cwd


if ( $#argv == 0 ) then
  set dev = 3
  set back = n
else
  set dev = 1
  if ( $#argv == 2 ) then
    set back = y
  else
    set back = n
  endif
endif


start:
set root = ` `

set stn      = `cat .lims.stn`
set dbase    = `cat .lims.dbase`
set stn_dir  = `cat .lims.stn_dir`
set lims_dir = `cat .lims.lims_dir`
set quick    = `cat .lims.quick`



cd $stn_dir

  echo  ' ' 
  echo  '  RESPONSE FILES FOUND IN: '$stn_dir
  echo  ' '
  ls *.dat

  if( -e $stn'r.dat' || -e $stn'cr.dat' ) set r = r
  if( -e $stn'l.dat' || -e $stn'cl.dat' ) set r = l

  if( ( -e $stn'r.dat' || -e $stn'cr.dat' ) && ( -e $stn'l.dat' || -e $stn'cl.dat' ) ) then
    echo ' '
    echo 'Both local & remote response files found ... plot local or remote ?'
response_select:
    echo -n 'Response (l/r) =>'$root
    set r=$<
    if( $r != 'r'  &&  $r != 'l' ) then
      echo 'Incorrect response -- re-enter'
      goto response_select
    endif
  endif

  if ( -e $stn$r'.dat' && -e $stn'c'$r'.dat' ) then
    echo ' '
    echo 'Both jones & chave response files found ... plot jones or chave ?'
chave_select:
    echo -n 'Response (j/c) =>'$root
    set j=$<
    if ( $j != 'j' &&  $j != 'c' &&  $j != 'b' ) then
      echo 'Incorrect response -- re-enter'
      goto response_select
    endif
  else if ( -e $stn$r'.dat' ) then
    set j = 'j'
  else if ( -e $stn'c'$r'.dat' ) then
    set j = 'c'
  endif

  if ( $j == 'c' ) then
    cp $stn_dir/$stn'c'$r'.dat' ../mt.dat
  else
    cp $stn_dir/$stn$r'.dat'    ../mt.dat
  endif

title:
  set title = $stn$j$r
  if ( $quick != y ) then
    echo ' '
    echo -n 'Enter title [default: '$title' ] =>'
    set ans = $<
    if ( $ans != "" ) set title = $ans
  endif
    
  cd $lims_dir$dbase

  rm -f $title.ps >& /dev/null
  scripts/mt_plot  mt.dat  $title

  rm mt.dat

  echo ' '
  echo -n 'Hardcopy of the plot y/n ? >'$root
  set ans = $<
  if( $ans == y ) then
    lpr -Pps $title.ps
  endif


exit:
  cd $old

