#!/bin/csh  -f
#
#  lims_remotes
#
#  derives remotes from given station number and windows.xxx file
#


set lims_dir = '/local/mt/lims/data/'
onintr exit

set old=$cwd

if ($#argv == 0) then
  echo 'Entered lims_remotes script...'
  echo 'USAGE: lims_remotes <site_number>'
  echo 'i.e. : lims_remotes 001'
  echo 'Window? >'
  set window = $<
else
  set window = $argv[1]
endif

set dbase = `echo $cwd | awk -F/ '{print $NF}'` 

cd $lims_dir$dbase

echo ' '
set line = `grep $window windows.$dbase`
echo $line > .lims_local
set stime = `awk -F-  '{print $1}' .lims_local | awk '{print $4}'`
set etime = `awk -F-  '{print $2}' .lims_local | awk '{print $1}'`

echo 'Start and end times for window: stime: '$stime  '   etime: '$etime

echo 'wlength -1 > .lims.duration  <<END'       > .lims_wlength
echo '-1'                                       >> .lims_wlength   #iprint
echo $stime                                     >> .lims_wlength   #start time
echo $etime                                     >> .lims_wlength   #end time
chmod +x .lims_wlength
.lims_wlength
set duration = `cat .lims.duration`

echo 'Window has interval: ' $stime'-'$etime'   duration: '$duration
echo ' '
echo 'Determining possible remote-reference windows'
echo 'woverlap -1 <<END >.lims.remote'                    >  .lims_woverlap
echo '-1'                                                 >> .lims_woverlap
echo $window                                              >> .lims_woverlap
echo 'T'                                                  >> .lims_woverlap
echo 'F'                                                  >> .lims_woverlap
echo 'END'                                                >> .lims_woverlap
chmod +x .lims_woverlap
.lims_woverlap
sort +4 .lims.remote
