c  tscombine: v4.2: 28 March 1998
c
c  reads in two ts files and combines them as required
c  (swaps any channel)

      implicit none

      include 'version.inc'
      include 'ctrlblk.inc' 
      include 'io.inc' 
      include 'infoblk.inc'
      include 'defaults.inc'
      include 'bdate.inc'

      character cchan*1

      integer narg, getnarg, i, instr1, instr2, ipt, i1, i2

      integer npt, nchanout, ichan(5)

      real    dat(5), dat1(5), dat2(5), delta1, delta2, totn
      real    misdat1, misdat2
      real    misdat1l, misdat1u, misdat2l, misdat2u

      integer daterr, sdur, nskip
      integer yy, mm, dd, hh, min, ss, dday, dhour, dmin, dsec, tsec
      integer nchan1, nchan2
      integer sensor1(5), sensor2(5)
      integer byy,  bmm,  bdd,  bhh,  bmin,  bss, inc
      integer byy1, bmm1, bdd1, bhh1, bmin1, bss1, inc1
      integer byy2, bmm2, bdd2, bhh2, bmin2, bss2, inc2

      integer tdiff

      integer imap(10)

      real lat1, long1, lat2, long2, elev1, elev2 
      real azim1(5), azim2(5), dec1, dec2, dec
      real gain1(5), gain2(5)
      real baseline1(3), baseline2(3)
      character chan1(5)*2, chan2(5)*2, units1(5)*10, units2(5)*10

      character fout*40, indat1*40, indat2*40, dur*10
      character proj*3, sep*1 
      character*5 tunits1, tunits2
      character*8 tswindow1, tswindow2, tswindowout
      character*6 stat1, stat2, statnew
      character*19 stime, etime, stime1, etime1, stime2, etime2
      character*10 cmdarg
      character*17 azdir1, azdir2
      character*15 form1, form2, format1, format2, formo, formato
      character*80 line
      character*24 date_string

c-------------------------------------------------------------------------------
c     get date

      call fdate(date_string)
c-------------------------------------------------------------------------------

      iprint = 0

c-------------------------------------------------------------------------------
c     Initialize variables and arrays.

      call dirsep(sep)
      inc   = 2
      inc1  = 2
      inc2  = 2

c-------------------------------------------------------------------------------
c     get command-line arguments

      narg = getnarg()
      do i = 1, narg
        call getcmdarg( i, cmdarg)
        if( index(cmdarg,'h').ne.0 ) then
          write(*,*)'Permitted options:-'
          write(*,*)'                    -1  or -2  iprint level'
          stop
        else
          read(cmdarg,'(i2)') iprint
        endif
      enddo

      call iin( 'Give print level (-1/0/1/2/3)', iprint)

c-------------------------------------------------------------------------------
c...write out banner

      call banner( 'TSCOMBINE' )

c-------------------------------------------------------------------------------
c  Read in the name of the input data file

      call nin('The FIRST file is the one used for station '//
     &         'co-ordinates and declination')

      tswindow1 = 'tbt101ss'
  300 call tin( 'Give first window (extension assumed)', tswindow1 )

      proj  = tswindow1(1:3)
      stat1 = tswindow1(1:6)

      tswindow2 = tswindow1
      call tin( 'Give second window (no extension)', 
     &             tswindow2 )
      stat2 = tswindow2(1:6)

      if( iprint.ge.1 ) then
        write(*,*)'Data files to open ==>'
        write(*,*)' file1 =>', tswindow1
        write(*,*)' file2 =>', tswindow2
      endif

      statnew = tswindow1
      call tin( 'Give output station name '//
     &          '(directory MUST exist!)', statnew )

c-------------------------------------------------------------------------------
c
c Open the data file and read in the window and header file information.
c

c...open FIRST file
      form = '?'
      write(*,*)'Opening input file for window ', tswindow1
      call ts_open( ind1, tswindow1, indat1, .FALSE., .FALSE. )
      write(*,*)'Opened data file =>',indat1
      call ts_rdinfo(ind1)

c..ts_stat common
      stat1 = stat

c..ts_pos common
      lat1  = lat
      long1 = long
      elev1 = elev

c..ts_instr common
      instr1 = instrument
      do i = 1, nchan
        sensor1(i) = sensor(i)
      enddo

c...ts_form common
      form1   = form
      format1 = format

c..ts_data common
      if( tunits.eq.'s' ) delta = 1./delta
      delta1  = delta
      tunits1 = tunits
      nchan1  = nchan
      do i = 1, nchan1
        chan1(i) = chan(i)
        gain1(i) = gain(i)
        units1(i) = units(i)
      enddo
      do i = 1, 3
        baseline1(i) = baseline(i)
      enddo
      misdat1 = misdat

c..ts_azim common
      do i = 1, 5
        azim1(i) = azim(i)
      enddo
      dec1 = declination

c..ts_start common
      stime1 = starttime
      call date( 0, stime1, byy, bmm, bdd, bhh, bmin, bss )
      if( iprint.ge.1 ) write(*,*) 'block start time=', stime1
      byy1 = byy
      bmm1 = bmm
      bdd1 = bdd
      bhh1 = bhh
      bmin1= bmin
      bss1 = bss


c...open SECOND file
      form = '?'
      write(*,*)'Opening input file for window ', tswindow2
      call ts_open( ind2, tswindow2, indat2, .FALSE., .FALSE. )
      call ts_rdinfo(ind2)
      
c..ts_stat common
      stat2 = stat

c..ts_pos common
      lat2  = lat
      long2 = long
      elev2 = elev

c..ts_instr common
      instr2 = instrument
      do i = 1, nchan
        sensor2(i) = sensor(i)
      enddo
      
c...ts_format common
      form2   = form
      format2 = format
      
c..ts_data common
      if( tunits.eq.'s' ) delta = 1./delta
      delta2  = delta
      tunits2 = tunits
      nchan2  = nchan
      do i = 1, nchan1
        chan2(i) = chan(i)
        gain2(i) = gain(i)
        units2(i) = units(i)
      enddo
      do i = 1, 3
        baseline2(i) = baseline(i)
      enddo
      misdat2 = misdat

c..ts_azim common
      do i = 1, 5
        azim2(i) = azim(i)
      enddo
      dec2 = declination

c..ts_start common
      stime2 = starttime
      call date( 0, stime2, byy, bmm, bdd, bhh, bmin, bss )
      if( iprint.ge.1 ) write(*,*) 'block start time=',stime2
      byy2 = byy
      bmm2 = bmm
      bdd2 = bdd
      bhh2 = bhh
      bmin2= bmin
      bss2 = bss

      if(delta1.ne.delta2) then
        write(*,*) 'Sampling rates differ between the two data files'
        stop
      endif

c------------------------------------------------------------------------------
c
      if( misdat1.ne.misdat2 ) then
        write(*,*)'Missing data markers are not the same:'
        write(*,*)'File 1: ', misdat1
        write(*,*)'File 2: ', misdat2
      endif

c------------------------------------------------------------------------------
c     open output file

c...set form and format to BINARY and UNFORMATTED
      formo   = 'BINARY'
      formato = 'UNFORMATTED'
      form   = formo
      format = formato

      tswindowout = statnew//'cb'
      write(*,'(a)') 'Opening output file: '// tswindowout
      call ts_open( outd1, tswindowout, fout, .FALSE., .FALSE. )

c------------------------------------------------------------------------------
c     get start and end times from windows file
c
      fout = 'windows.'//proj
      goto 405
  400 call tin (' Give the project windows file', fout )
  405 open ( inc, file=fout, status='old', form='formatted', err=410 )
      go to 420
  410 write (*,*) 'Error opening WINDOWS file, re-enter'
      go to 400
  420 continue


      call getwindow( inc, tswindow1, instr1, nchan1, stime1, etime1 )
      rewind( inc )
      call getwindow( inc, tswindow2, instr2, nchan2, stime2, etime2 )
      if( iprint.ge.0 ) then
        write(*,*)'File 1 start and end times:', stime1,'-',etime1
        write(*,*)'File 2 start and end times:', stime2,'-',etime2
      endif
      close(inc)

c...get start and end times of output file

900   if( iprint.ge.0 ) then
        write(*,'(2a)') 'Give the required event start time >',
     &            'yyyy-mm-dd hh:mm:ss'
      endif
      if( tdiff(stime1,stime2).le.0 ) then
        stime = stime1
      else
        stime = stime2
      endif
      call tin ( ' ', stime )
      call date( 0, stime, yy, mm, dd, hh, min, ss )
      if( iprint.ge.2 ) then
        write(*,*)'stime=',stime
        write(*,*)' yy, mm, dd, hh, min =>', yy, mm, dd, hh, min, ss
      end if

      call chkdat( yy, mm, dd, hh, min, ss, daterr )
      if( daterr .gt. 0 ) go to 900

905   if( iprint.ge.0 ) then
        write(*,'(2a)') 'Give the required event end   time >',
     &            'yyyy-mm-dd hh:mm:ss'
      end if
      if( tdiff(etime1,etime2).ge.0 ) then
        etime = etime1
      else
        etime = etime2
      endif
      call tin ( ' ', etime )
      call date( 0, etime, yy, mm, dd, hh, min, ss )
      if( iprint.ge.2 ) then
        write(*,*)'etime=',etime
        write(*,*)' yy, mm, dd, hh, min =>', yy, mm, dd, hh, min, ss
      endif

      call chkdat( yy, mm, dd, hh, min, ss, daterr )
      if( daterr .gt. 0 ) go to 905

      call date( 0, stime, yy, mm, dd, hh, min, ss )


c...sdur is the duration in seconds from the start time to the end
      sdur = tdiff( stime, etime )

      dday  =  sdur/(60*60*24)
      dhour =  mod(sdur,60*60*24)/(60*60)
      dmin  =  mod(sdur,60*60)/60
      dsec  =  mod(sdur,60)

      if( iprint.ge.0 ) then
        write( dur, '(i4.4,a1,i2.2,a1,i2.2)') 
     &           dday, '/', dhour, '/', dmin
        write(*,'(2a)') 'Duration (dddd/hh/mm) : ', dur
      end if

      if(dday.eq.0 .and. dhour.eq.0 .and. dmin.eq.0 .and. dsec.eq.0)then
        dday  =  sdur/(60*60*24)
        dhour =  mod(sdur,60*60*24)/(60*60)
        dmin  =  mod(sdur,60*60)/60
        dsec  =  mod(sdur,60)
      endif


c...calculate the total number of seconds of data of overlap

      tsec = dday*86400 + dhour*3600 + dmin*60 + dsec

c...totn is the total number of entries required for analysis.
c
      totn =  float(tsec) * delta 
      npt = ifix(totn)

      write(*,*) 'Total number of data requested:', npt

c-------------------------------------------------------------------------------
c     write out co-ordinates and request direction for rotation

 
      write(*,*)'Co-ordinates of acquisition ==>'
      do i = 1, nchan1
        write(*,*) 'File 1: Channel:', i,'   azimuth =', azim1(i)
      enddo
      do i = 1, nchan2
        write(*,*) 'File 2: Channel:', i,'   azimuth =', azim2(i)
      enddo

      if( index(azdir1, 'MAGNETIC').ne.0 .or.
     &      index(azdir2, 'MAGNETIC').ne.0 ) then
        call iin( 'Give declination of output file', dec )
      endif

c-------------------------------------------------------------------------------
c     request which channels to write out

      nchanout = max( nchan1, nchan2 )
      call iin( 'No. of output channels', nchanout )
      write(*,*)'You will now be asked for the mapping of each '//
     &          'output channel'
      write(*,*)'Answers should be a two-digit integer with 1st '//
     &          'digit for file number, 2nd digit for channel'
      write(*,*)' e.g.,   23   = file 2, channel 3'
      do i = 1, nchanout
        write(cchan,'(i1)') i
        write(*,'(a,$)') 'Give mapping file for channel '//cchan//' >'
        read(*,*) imap(i)
      enddo

c-------------------------------------------------------------------------------
c   write comment block out  - use location of first file

      line = '# tscombine: '//ver
      write(outd1) line
      line = '# date: '//date_string
      write(outd1) line
      line = '#'
      write(outd1) line
      line = '# File 1: '//tswindow1
      write(outd1) line
      line = '# File 2: '//tswindow2
      write(outd1) line
      line = '#'
      write(outd1) line
      line = '# No. of channels in output file: '
      write(line(35:),*) nchanout
      write(outd1) line
      line = '# Chosen from file: '
      write(line(21:),'(10i3)') (ichan(i),i=1,nchanout)
      write(outd1) line
      line = '#'
      write(outd1) line
      line = '#--------------------------------------------------'
      write(outd1) line
      line = '# Comment block from File 1: '//tswindow1
      write(outd1) line
      rewind(ind1)
      call ts_copycomm( ind1, form1, outd1, formo )
      line = '#'
      write(outd1) line
      line = '#--------------------------------------------------'
      write(outd1) line
      line = '# Comment block from File 2: '//tswindow2
      write(outd1) line
      rewind(ind2)
      call ts_copycomm( ind2, form2, outd1, formo )

c...skip over info blocks
      form = form1
      call ts_rdinfo(ind1)
      form = form2
      call ts_rdinfo(ind2)

c-------------------------------------------------------------------------------
c   write info block out  - use location of first file

      stat = statnew
      window = tswindowout
      lat  = lat1
      long = long1
      elev = elev1
      
      form = formo

      starttime = stime
      endtime   = etime

      instrument = 900 + instr1
      
      nchan = nchanout
      do i = 1, nchan
        i1 = imap(i)/10
        i2 = imap(i) - 10*i1
        if( i1.eq.1 ) then
          chan(i)  = chan1(i2)
          azim(i)  = azim1(i2)
          gain(i)  = gain1(i2)
          units(i) = units1(i2)
          sensor(i) = sensor1(i2)
          if(i.le.3) baseline(i)=baseline1(i2)
        else
          chan(i)  = chan2(i2)
          azim(i)  = azim2(i2)
          gain(i)  = gain2(i2)
          units(i) = units2(i2)
          sensor(i) = sensor2(i2)
          if(i.le.3) baseline(i)=baseline2(i2)
        endif
      enddo

c...set missing data marker to default
      misdat = DEFMISDAT
      call ts_wrtinfo( outd1 )

c-------------------------------------------------------------------------------
c....skip data for data start times < stime

      if( tdiff(stime1,stime).gt.0 ) then
        if( tunits.eq.'Hz' ) then
          nskip = tdiff( stime1, stime ) * delta
        else
          nskip = tdiff( stime1, stime ) / delta
        endif
        write(*,*)'Skipping', nskip, '  data for File 1'
        call ts_skip( ind1, nskip )
      else
        write(*,*)'No data skipping for File 1'
      endif

      if( tdiff(stime2,stime).gt.0 ) then
        if( tunits.eq.'Hz' ) then
          nskip = tdiff( stime2, stime ) * delta
        else
          nskip = tdiff( stime2, stime ) / delta
        endif
        write(*,*)'Skipping', nskip, '  data for File 2'
        call ts_skip( ind2, nskip )
      else
        write(*,*)'No data skipping for File 2'
      endif

c-------------------------------------------------------------------------------

      misdat1l = misdat1*0.99
      misdat1u = misdat1*1.01
      misdat2l = misdat2*0.99
      misdat2u = misdat2*1.01

      do ipt = 1, npt

c...read in data frm File 1
        nchan = nchan1
        form  = form1
        call ts_in1(ind1, dat1)
        if( dat1(1).eq.EOF ) goto 30
        if( iprint.ge.3 ) then
          write(*,*) 'Input dat1  =>', (dat1(i),i=1,nchan1)
        endif
c...set to DEFMISDAT if within 1% of misdat1
        do i = 1, nchan1
          if( dat1(i).gt.misdat1l .and. dat1(i).lt.misdat1u ) then
            dat1(i) = DEFMISDAT
          endif
        enddo


c...read in data from File 2 
        nchan = nchan2
        form  = form2
        call ts_in1(ind2, dat2)
        if( dat2(1).eq.EOF ) goto 31
        if( iprint.ge.3 ) then
          write(*,*) 'Input dat2 =>', (dat2(i),i=1,nchan2)
        endif
c...set to DEFMISDAT if within 1% of misdat1
        do i = 1, nchan2
          if( dat2(i).gt.misdat2l .and. dat2(i).lt.misdat2u ) then
            dat2(i) = DEFMISDAT
          endif
        enddo

        nchan = nchanout
        do i = 1, nchan
          i1 = imap(i)/10
          i2 = imap(i) - 10*i1
          if( i1.eq.1 ) then
            dat(i) = dat1(i2)
          else
            dat(i) = dat2(i2)
          endif
        enddo

        form = formo
        call ts_out1( outd1, dat )

      enddo

      write(*,*)' Number of points written: ', npt

      stop 'Done.'

30    write(*,*)'EOF of File 1'
      stop
31    write(*,*)'EOF on File 2'
      stop
      
      end
