c  tsmean: v5.0: 18 October 2000
c
c  derives mean of each series in a ts file and removes it
c


      implicit none

      include 'version.inc'
      include 'defaults.inc'
      include 'ctrlblk.inc' 
      include 'io.inc' 
      include 'infoblk.inc'
      include 'bdate.inc'
      include 'op_sys.inc'

      integer narg, getnarg, i, ipt, instr, datchk, sdur, tdiff
      integer npt, nskip

      real dat(5), mean(5)

      character indat*40, fout*20
      character*3 proj
      character*1 sep
      character*8 tswindow
      character*6 stat
      character*19 stime, etime
      character*10 cmdarg
      character*13 dur
      character*80 line
      character*60 path
      character*24 date_string
      character*6 progprec

      logical SINGLE, PROMPT

c-------------------------------------------------------------------------------
c     Initialize variables and arrays.

      call getdir(path)

      call fdate(date_string)
      call chkend(sysend)

      call precision( SINGLE )
      if( SINGLE ) then
        progprec = 'SINGLE'
      else
        progprec = 'DOUBLE'
      endif

      call dirsep(sep)

c-------------------------------------------------------------------------------
c     get command-line arguments

      narg = getnarg()
      do i = 1, narg
        call getcmdarg( i, cmdarg)
        if( index(cmdarg,'h').ne.0 ) then
          write(*,*)'Permitted options:-'
          write(*,*)'                    -1 -> -3  iprint level'
          stop
        else
          read(cmdarg,'(i2)') iprint
        endif
      enddo

      call iin( 'Give print level (-1/0/1/2/3)',iprint)


c-------------------------------------------------------------------------------
c...write out banner

      call banner( 'TSMEAN' )

c-------------------------------------------------------------------------------
c...open input data file and read in info block

      form = '?'
      PROMPT = .TRUE.
      tswindow = ' '
      call ts_open( ind1, tswindow, indat, PROMPT, .FALSE. )

c...read info block
      call ts_rdinfo(ind1)

c...convert delta to samples/s
      if( tunits.eq.'s' ) delta = 1./delta

c-------------------------------------------------------------------------------
c...open windows file and get start and end times of data

      proj = tswindow(1:3)
      fout = 'windows.'//proj
      open ( ind2, file=fout, status='old', form='formatted', err=9002 )
      call getwindow( ind2, tswindow, instr, nchan, stime, etime )
      if( iprint.ge.1 ) then
        write(*,*)' window start and end times:', stime,'-',etime
      endif
      close(ind2)


c-------------------------------------------------------------------------------
c...get start and end times of region to have mean removed

900   if( iprint.ge.0 ) then
        write(*,'(2a)') 'Give the required event start time          >',
     &            'yyyy-mm-dd hh:mm:ss'
      endif
      call tin( 'Default is', stime )
      if( datchk( stime ).ne.0 ) goto 900


905   if( iprint.ge.0 ) then
        write(*,'(2a)') 'Give the required event end   time          >',
     &            'yyyy-mm-dd hh:mm:ss'
      end if
      call tin( 'Default is', etime )
      if( datchk( etime ).ne.0 ) goto 905


c...sdur is the duration in seconds from the start time to the end
      sdur = tdiff( stime, etime )
      npt = ifix( float(sdur) * delta )
      call duration( stime, etime, dur )

      if( iprint.ge.0 ) then
        write(*,*) 'Duration (dddd/hh/mm:ss) = ', dur
        write(*,*) 'No. of points            = ', npt
      endif

c-------------------------------------------------------------------------------
c....skip data for data start times < stime
      if( starttime.lt.stime ) then
        nskip = tdiff( starttime, stime ) * delta
        write(*,*)'Skipping', nskip, '  data for local  file'
        call ts_skip( ind1, nskip )
      endif

c-------------------------------------------------------------------------------
c...read in data and derive mean values

      do i = 1, nchan
        mean(i) = 0.0
      enddo

      do ipt = 1, npt
        call ts_in1(ind1, dat)

        if( dat(1).eq.EOF ) goto 9001

        do i = 1, nchan
          if(dat(i).ne.misdat) mean(i) = mean(i) + dat(i)
        enddo
      enddo

      do i = 1, nchan
        mean(i) = mean(i)/float(npt)
        write(*,*)'Channel', i,'    mean =', mean(i)
      enddo

c-------------------------------------------------------------------------------
c...open output file and write out modified comment and info blocks

      tswindow(7:8) = 'mx'
      call tin( 'Give output window name', tswindow )
      fout = tswindow(1:6)//'/'//tswindow//'.ts'
      if( form.eq.'BINARY' ) then
        open(unit=outd1,file=fout,form='unformatted')
        write(*,*)'Opened BINARY output file >', fout
      else
        open(unit=outd1,file=fout)
        write(*,*)'Opened ASCII output file >', fout
      endif

      if( form.eq.'ASCII' ) then
        write(outd1,'(a)') '# tsmean: means removed'
        write(outd1,'(a)') '# date: '//date_string
        write(outd1,'(a)') '#'
        do i = 1, nchan
         write(outd1,'(a,i1,a,g20.8)') '# Channel ', i, 
     &                                 '   Mean =', mean(i)
        enddo
        write(outd1,'(a)') '#'
      else
        line = '# tsmean: means removed'
        write(outd1) line
        line = '# date: '//date_string
        write(outd1) line
        line = '#'
        write(outd1) line
        do i = 1, nchan
          line = '# Channel 0   Mean ='
          write(line(11:11),'(i1)') i
          write(line(21:40),'(g20.8)') mean(i)
          write(outd1) line
        enddo
        line = '#'
        write(outd1) line
      endif

c...rewind data file to beginning and copy comment block
      rewind(unit=ind1)
      call ts_copycomm( ind1, form, outd1, form )

c...read in info block, modify some parameters, and write it out
      call ts_rdinfo( ind1 )
      starttime = stime
      endtime   = etime
      call ts_wrtinfo( outd1 )

c-------------------------------------------------------------------------------
c....skip data for data start times < stime
      if( starttime.lt.stime ) then
        nskip = tdiff( starttime, stime ) * delta
        write(*,*)'Skipping', nskip, '  data for local  file'
        call ts_skip( ind1, nskip )
      endif

c-------------------------------------------------------------------------------
c...read in data, subtract means, and write data out

      do ipt = 1, npt
        call ts_in1(ind1, dat)

        if( dat(1).eq.EOF ) goto 9001

        do i = 1, nchan
          if(dat(i).ne.misdat) dat(i) = dat(i) - mean(i)
        enddo

        call ts_out1(outd1, dat)
      enddo

c-------------------------------------------------------------------------------
c...end

      stop 'tsmean completed'

9001  stop '***File ended before all data could be read in'
9002  stop '***Error opening windows file'
9999  stop 'Error '
      END
