c=====================================================================
      program tsmultiplot
c
c     based on "limsplot" by Jim Craven
c=====================================================================
      implicit none
c--------------------------------------------------------------------

      include 'version.inc'
      include 'ctrlblk.inc' 
      include 'infoblk.inc' 
      include 'defaults.inc' 
      include 'io.inc'
      include 'bdate.inc'

      include 'tsmultiplot.h'

      real data1(MAXCHAN), datum, data(5, MAXNUM)

      character indat*19, tswindow*8, dur*6
      character s*1, time*12, stime*12, etime*12, etime_save*12
      character*12 starttimes(MAXCHAN)
      character comptype(5)*2, compx*2, stat*6
      character*19 indats(MAXCHAN)
      
      integer ind, prterr, nchan, iprint
      integer daterr
      integer byy, bmm, bdd, bhh, bmn, bss
      integer yy, mm, dd, hh, smn, ss
      integer inc, i
      integer ifile
      integer stsec, tsec, ifds(MAXCHAN)
      integer nchanx, instr, tpts, too_many_pts, npt

      integer its, ipt, npts_tot, navgs(MAXCHAN)
      integer ichan_select, j, ifile
      integer ibase, ifile_start, block_min
     
      integer tdiff, k, ke, isc
      integer mwindow, dday, dmn, dss, dhour
c
      logical equalize

      real    delta, dpi, d
      real scmin(MAXCHAN)

      character*24 date_string

c-------------------------------------------------------------------------------
c     get date

      call fdate(date_string)

c-------------------------------------------------------------------------------
c     Initialize variables and arrays.

      call dirsep(sep)

c-------------------------------------------------------------------------------
c     get command-line arguments

      narg = getnarg()
      do i = 1, narg
        call getcmdarg( i, cmdarg)
        if( index(cmdarg,'h').ne.0 ) then
          write(*,*)'Permitted options:-'
          write(*,*)'                    -1 -> 3  iprint level'
          stop
        else
          read(cmdarg,'(i2)') iprint
        endif
      enddo

      call iin( 'Give print level (-1/0/1/2/3)',iprint)


c-------------------------------------------------------------------------------

      if( iprint.ge.1 ) then
        write(*,*)' '
        write(*,*)' >>>>>>>>>>>>> TSEXTRACT <<<<<<<<<<<<<<<<<'
        write(*,*)' '
        write(*,*)'           version = ', ver
        write(*,*)'build date = ', bdate
        write(*,*)' '
        write(*,*)'It is assumed that this program is being run from'
        write(*,*)'the database directory of the project '
        write(*,*)'(e.g. /local/mt/lims/nod)  '
        write(*,*)'and that all data files reside in subdirectories'
        write(*,*)'with the respective station names '
        write(*,*)'(e.g. /local/mt/lims/nod/nod001 nod002 etc.)'
        write(*,*)' '
        write(*,*)'windows and hardware database files are required'
        write(*,*)'(e.g. windows.nod & hardware.nod) '
        write(*,*)' '
      endif

c-------------------------------------------------------------------------------
c...set misdat here to an absurd number. 
c   May get overwritten on reading data in

      misdat = 9.9999999E+9

c...set dots/inch resolution required
      dpi = 600.

c------------------------------------------------------------------------------
c Initialize variable default values

      ifile = 0
      do its=1, MAXCHAN
         ins(its) = 1
         xxmin(its) = 32000
         xxmax(its) = -32000
         npts(its) = 0
         navgs(its) = 0
      end do
      comptype(1) =  'HX'
      comptype(2) =  'HY'
      comptype(3) =  'HZ'
      comptype(4) =  'EX'
      comptype(5) =  'EY'
      call dirsep(s)
      call getctrl_blk()
      prterr = iprint
      
      nfiles=5
      call iin('Number of ts files to read?', nfiles)

      its = 0
c     --- read in the headers 
      stat = 'brt092'
      do ifile = 1, nfiles
        ind = 20+ifile
        form = '?'
        tswindow=' '
        call ts_open(ind,tswindow,indat,.TRUE.,.FALSE.)
        call ts_rdinfo(ind)

        if( iprint.ge.1 ) call ts_prtinfo

        read( starttime, '(6i2)') byy, bmm, bdd, bhh, bmn, bss
        block_start(1,ifile) = byy
        block_start(2,ifile) = bmm
        block_start(3,ifile) = bdd
        block_start(4,ifile) = bhh
        block_start(5,ifile) = bmn
        block_start(6,ifile) = bss
        call consec(stsec,byy,bmm,bdd,bhh,bmn,bss)
        block_start(7,ifile) = stsec

        windows(ifile) = tswindow
        starttimes(ifile) = starttime
        deltas(ifile) = delta
        prterrs(ifile) = prterr
        nchans(ifile) = nchan
c        do ibase = 1, 3
c           baselns(ibase,ifile) = baseline(ibase)
c        end do
         
c        ---check some parameters are consistent
         do j = 1, ifile-1
            if(byy.ne.block_start(1,j)) then
               write(*,*)' Mismatched years in current file',
     &              ' and file ',filenames(j),' :'
               write(*,*)byy, block_start(1,j)
               stop
            endif
            if (delta.ne.deltas(j)) then
               write(*,*)' Mismatched deltas in current file',
     &              ' and file ', filenames(j),':'
               write(*,*) delta, deltas(j)
               write(*,*)' Fix header or use resamp.'
               stop
            endif
         end do
c        --- record longest time
         open(unit=ind2,file='windows.'//window(1:3))
         call getwindow( ind2, tswindow, instr, nchanx, stime, etime )
         close(unit=ind2)
         if(etime.gt.etime_save) then
            etime_save = etime
         endif

c        --- determine the components to plot from this file
         write(*,*)' '
         write(*,'(2x,a)')
     &        ' Channel          Component'
         do j = 1, nchan
            write(*,'(4x,i2,15x,a2)')
     &           j, chan(j)
         end do
         write(*,*) '    0              Done'
         ichan_select = 1
 10      continue

           if(its.ge.MAXCHAN) then
              write(*,*)' Maximum no of traces hit...'
              nfiles = ifile
              goto 20
           endif
           call iin( 'Select channel to plot, enter an integer (1-5)',
     &        ichan_select)
           if(ichan_select.gt.5.or.ichan_select.lt.0) then
              write(*,*) ' Must enter a number between 0 and 5'
              ichan_select = 1
              goto 10
           endif
           if(ichan_select.ne.0) then
c             --- we have selected a valid ts
              its = its + 1
c             ---  ifiles and icomp map a time series to its file: v. impt
              ifiles(its) = ifile
              icomp(its) = ichan_select
c              --- check if we need to use auxilliary data
              j = icomp(its)
c             --- prompt for another channel from this window
              ichan_select = 0
              goto 10
           endif
      enddo
 20   nts = its
c
c     --- find the ts that starts first
      ifile_start=0
      block_min = 31536000
      do ifile = 1, nfiles
         if ( block_start(7,ifile).lt.block_min) then
            ifile_start = ifile
            block_min = block_start(7,ifile)
         end if
      end do
      if(ifile_start.eq.0) then
         write(*,*)'TSMULTIPLOT: unable to determine start timeseries'
         stop
      endif
c
c     --- get the plot start time (stsec)
  110 continue
      yy=block_start(1,ifile_start)
      mm=block_start(2,ifile_start)
      dd=block_start(3,ifile_start)
      hh=block_start(4,ifile_start)
      smn=block_start(5,ifile_start)
      ss=block_start(6,ifile_start)
      call date( 1, stime, yy, mm, dd, hh, smn, ss )
      write(*,*)' Give the required event start time >'//stime
      call tin( 'Default is', stime )

      call date( 0, stime, yy, mm, dd, hh, smn, ss )
      call chkdat( yy, mm, dd, hh, smn, ss, daterr )
      if( daterr .gt. 0 ) go to 110

      if ( yy .ne. block_start(1,1) ) then
        write(*,'(a, i4)')' Requested wrong year!  Data block year is',
     &                      block_start(1,1)
        go to 110
      end if


c...use window with longest endtime to calculate a duration
      mwindow = tdiff(stime,etime_save)
      dday  = mwindow/1440
      dhour = (mwindow - 1440*dday)/60
      dmn  = mwindow - dday*1440 - dhour*60
      tsec =   ((dday*24+dhour)*60 + dmn)*60 + dss
      tpts = nint(float(tsec)*delta)
      too_many_pts = tpts - MAXNUM
      if(too_many_pts.gt.0) then
         tpts = MAXNUM
         tsec = float(tpts)/delta
         write(*,*)' Program dimensions insufficient to display',
     &        ' all data.'
         mwindow = tsec/60
         dday = mwindow/1440
         dhour = (mwindow - 1440*dday)/60
         dmn  = mwindow - dday*1440 - dhour*60
      endif
      write( dur, '(3i2.2)') dday, dhour, dmn 
      call tin( 'Give duration (ddhhmm)', dur )
      read( dur,'(3i2)') dday, dhour, dmn

c     --- Calculate the total number of seconds and points to be plotted.      
      tsec =   ((dday*24+dhour)*60 + dmn)*60 + dss
      npt = tsec / delta
      if(iprint.ge.0) then
         write(*,*)'No of seconds & points to plot = ', tsec, npt
      endif
      do its = 1, nts
        npts(its) = npt
      enddo

c     --- set up and scale the x-axis
      call set_xscale(tsec,delta,dday, dhour, dmn,
     &                yy, mm, dd, hh, smn, ss)

c     --- read in tsec worth of data
      write(*,*)' Reading data ... please be patient ...'

      do ifile = 1, nfiles
        ind = 20+ifile
        call ts_read( ind, stime, etime, data )

c...calculate averages
      do its = 1, nts
         avgs(its) = avgs(its)/float(navgs(its))
      enddo

c...Calculate the scaling factors for each channel:
      do its = 1, nts
         sc(its) = ( float(xxmax(its))-float(xxmin(its)) )*
     >                (nts+1) * cals(icomp(its),ifiles(its))
         d = sc(its)
         do 220 k = 1, 12
            d = d/10.
            if ( d .lt. 1.0 ) go to 230
 220     continue
 230     continue
         d = sc(its)
         ke = k - 1
         isc = ifix( d/10.**ke )
         sc(its) = (float (isc + 1) )* (10**ke)
      enddo
c
      equalize = .true.
      call lin('Equalize default channel scalings?', equalize)
      if(equalize) then
c        -- find the min scale for each comp type
         do j = 1, 16
            scmin(j) = 1.e32
            do its = 1, nts
               if( icomp(its) .le.5 ) then
c                 uh?
                  compx=comps(mapcmps(icomp(its),ifiles(its)),
     &                 ifiles(its))
               else
                  compx=comps(icomp(its),ifiles(its))
               endif
               call shiftup(compx)
               if(compx.eq.comptype(j)) then
                  scmin(j) = min(scmin(j),sc(its))
               endif
            end do
         end do
c        --- set each trace to the min scale for its comp type
         do its = 1, nts
            if( icomp(its) .le.5 ) then
c             uh?
               compx=comps(mapcmps(icomp(its),ifiles(its)),
     &              ifiles(its))
            else
               compx=comps(icomp(its),ifiles(its))
            endif
            call shiftup(compx)
            do j = 1, 16
               if(compx.eq.comptype(j)) then
                  sc(its) = scmin(j)
               endif
            end do
         end do
      endif

c     --- Entry point to replot data with a different vertical scale.
  250 continue
      do its = 1, nts
         if( icomp(its) .le.5 ) then
            call rin(' No. of units equal to height of box: '
     &           //windows(ifiles(its))(4:)
     &           //' '//comps(mapcmps(icomp(its),ifiles(its)),
     &           ifiles(its)),   sc(its))
         else
            call rin(' No. of units equal to height of box: '
     &           //windows(ifiles(its))(4:)
     &           //' '//comps(icomp(its),ifiles(its)),
     &           sc(its))
         endif
      end do

c     --- plot frame
      call plot_frame()

c     --- plot the time series
      call plot_ts()

      call endplt

c     --- wrap up with a display of final end time in file
      stsec = stsec + (npts_tot)/delta
      call seccon(stsec,byy,bmm,bdd,bhh,bmn,bss)
      write(*,*)' '
      write(*,'(a,a,i4,5i3)')'Data end time  : year/month/day',
     >        '/hour/min/sec=', byy, bmm, bdd, bhh, bmn, bss
      stop

 7000 continue
      write(*,*)'TSMULTIPLOT: error reading header for file: ',
     &     indats(ifile)
      stop 
 8000 continue
      write(*,*)'TSMULTIPLOT: error reading file for window ',
     &     windows(ifile)
      stop
 9001 write (*, '(a)') ' ERROR converting integers to characters.'
      go to 9998
 9002 write (*, '(a)') ' ERROR converting characters to integers.'
      goto 9998

 9998 continue
      write(*,*)'Aborting...'
      stop

 9999 continue
      write(*,*)'Error opening file.'
      stop

      end
