      implicit none

      integer MAXCHAN, MAXNUM
      parameter ( MAXCHAN = 5, MAXNUM = 200 )
      
      include 'infoblk.inc'
      include 'defaults.inc'
      include 'ctrlblk.inc'
      include 'version.inc'
      include 'bdate.inc'

      character*19 indat, outfile

      character*80 line

      character*20 fout
      character tswindow*8, sep*1, otswindow*8, cdeploy*2, proj*3

      character*6 progprec

      character*1 inf, outf

      character*19 stime, etime, nowtim

      character*15 inform, outform, informat, outformat

      integer ind, outd, ind2, outd2, instr, i, j, k
      integer npt, nsec
      integer byy, bmm, bdd, bhh, bmin, bss
      integer iout, ncoeff, ifact, ioff, jj
      integer secf, lf
      integer*4 lnblnk

c...data declared as real*4 in case of double precision compilation
      real*4 dt(5,200), datout(5), last(5)

      real newdel, olddel, rout(5), filt(maxnum)
      real misdatl, misdatu

      character*24 date_string

      logical FORMATTED, SINGLE



	external date

c-------------------------------------------------------------------------------
c     determine precision

      call precision( SINGLE )
      if( SINGLE ) then
        progprec = 'SINGLE'
      else
        progprec = 'DOUBLE'
      endif

c-------------------------------------------------------------------------------
c     get date

      call fdate(date_string)

c-------------------------------------------------------------------------------
c    initialise

      call dirsep(sep)

      ind   = 4
      ind2  = 3
      outd  = 10
      outd2 = 11

      iprint = 0
      call iin( 'Give print level', iprint )

c-------------------------------------------------------------------------------
c    start

      if( iprint.ge.1 ) then
        write(*,*)' '
        write(*,*)' >>>>>>>>>>>>> TSRESAMP <<<<<<<<<<<<<<<<<<<'
        write(*,*)' '
        write(*,*)'             version = ', ver
        write(*,*)'build date = ', bdate
        write(*,*)' '
        if( SINGLE ) then
          write(*,*)'        SINGLE PRECISION version'
        else
          write(*,*)'        DOUBLE PRECISION version'
        endif
        write(*,*)' '
        write(*,*)'It is assumed that this program is being run from'
        write(*,*)'the database directory of the project '
        write(*,*)'(e.g. /local/mt/lims/nod)  '
        write(*,*)'and that all data files reside in subdirectories'
        write(*,*)'with the respective station names '
        write(*,*)'(e.g. /local/mt/lims/nod/nod001 nod002 etc.)'
        write(*,*)' '
        write(*,*)'windows and hardware database files are required'
        write(*,*)'(e.g. windows.nod & hardware.nod) '
        write(*,*)' '
      else
        write(*,'(a)')'tsresamp: ver='//ver//'   '//progprec//
     &                ' precision'
      endif

c-------------------------------------------------------------------------------
c     open input & output files

      tswindow = ' '
      form = '?'
      call ts_open(ind,tswindow,indat,.TRUE.,.FALSE.)
      proj = tswindow(1:3)
      ioff=ichar(tswindow(7:7))-ichar('a')

      if( format.eq.'UNFORMATTED' ) then
        inf = 'U'
      else
        inf = 'F'
      endif

      cdeploy = '1r'
      call tin('Enter new 2-char deployment code', cdeploy)

      otswindow = tswindow(1:6)//cdeploy
      outfile = tswindow(1:6)//sep//otswindow//'.ts'
       
      write(*,'(a)') 'Name of resampled output file is '//outfile


c-------------------------------------------------------------------------------

10    outf = 'u'
      call tin('FORMATTED ascii (f), or '//
     &         'UNFORMATTED binary (u) output?', outf)
      call shiftup( outf )

      if( outf.eq.'F' ) then
         FORMATTED = .TRUE.
         outform = 'ASCII'
         if( inform.eq.'ASCII' ) then
           outformat = informat
         else
           outformat = 'FREE'
         endif
15       call tin( 'Give o/p format (either FREE or specific '//
     &             'including brackets - max 15 char)', outformat )
         if( outformat.eq.'FREE' ) then
           write(*,'(a)')'FREE format chosen'
         else
c...check format has brackets at both ends
           lf = lnblnk( outformat )
           if( outformat(1:1).ne.'(' ) then
             write(*,'(a)')'Incorrect format - does not begin with a '//
     &                     '")"'
             goto 15
           elseif( outformat(lf-1:lf-1).ne.')' ) then
             write(*,'(a)')'Incorrect format - does not end with a ")"'
             goto 15
           endif
         endif
         write(*,'(a)')'Opened formatted file '//outfile
         open(outd,file=outfile,status='unknown', form='formatted')

      else if( outf.eq.'U' ) then
         FORMATTED = .FALSE.
         outform = 'BINARY'
         outformat = 'UNFORMATTED'
         write(*,'(a)')'Opened unformatted file '//outfile
         open(outd,file=outfile,status='unknown',
     &        form='unformatted')
      else
        write(*,*)'Unknown output type requested >',outf,'< '//
     &            'please re-enter'
        goto 10
      endif


      if( FORMATTED ) then
        write(outd,'(a)') '# time series file from ts_resamp: '//
     &                  'precision: '//progprec
        write(outd,'(2a)')  '# date: ', date_string
        write(outd,'(a)') '# '
        write(outd,'(2a)') '# input file =',indat
        write(outd,'(a)') '# '

      else
        line = '# time series file from ts_resamp'
        write(outd) line
        line = '# date: '//date_string
        write(outd) line
        line = '#'
        write(outd) line
        line = '# input file ='//indat
        write(outd) line
        line = '#'
        write(outd) line
      endif

c...copy the comment block information
      call ts_copycomm( ind, inf, outd, outf )

c...read the info block and puts pointer at beginning of data
      call ts_rdinfo(ind)
      inform   = form
      informat = format

      if( endtime(1:2).ne.'19' .or. endtime(1:2).ne.'20' ) then
        write(*,'(a)') 'No valid ENDTIME read in - reading '//
     &                 'windows file'
        open(unit=ind2,file='windows.'//proj,status='old',err=5)
        call getwindow( ind2, tswindow, instr, nchan, stime, endtime )
        close(unit=ind2)
        write(*,'(a)')'endtime in windows file ='//endtime
        goto 6
5       write(*,*)'No windows file found'
        close(unit=ind2)
      endif

6     if(tunits.eq.'Hz' ) then
         continue
      elseif(tunits.eq.'s')then
         delta = 1./delta
      else
        write(*,*)'Unknown time units in file =', tunits
        stop
      endif

      if(tunits.eq.'Hz') then
        if(delta.eq.64.) ifact = 4
        if(delta.eq.16.) ifact = 4
        if(delta.eq.4.0) ifact = 4 
        if(delta.eq.1.0) ifact = 5 
        write(*,'(a,f6.2,a)') 'Old sampling rate = ',delta ,' Hz'
        olddel = delta
        newdel = delta / float( ifact )

       else
        if(delta.eq.1.0) ifact = 5 
        if(delta.eq.0.2) ifact = 6
        olddel = delta
        newdel = delta / float(ifact)
        write(*,'(a,f6.2,a)') 'Old sampling rate = ',1./olddel,' sec'      
      end if

      if(newdel.ge.1.0) then
        if( tunits.eq.'s' ) tunits='Hz'
        write(*,'(a,f6.2,a)') 'New sampling rate = ',newdel ,' Hz'
       else
        if( tunits.eq.'Hz' ) tunits='s'
        write(*,'(a,f6.2,a)') 'New sampling rate = ',1.0/newdel,
     &                      ' sec'
      end if

      call load_filter(ifact,ncoeff,maxnum,filt)
      write(*,'(a,i3)')'Filter coefficient length =', ncoeff

c...find the start time of the filtered window

      write(*,'(a)')'Data     start: '//starttime
      call date(2,starttime,byy,bmm,bdd,bhh,bmin,bss)

      if( delta.gt.1. ) then
        secf = int((ncoeff-1)/delta)+1
      elseif( delta.eq.1. ) then
        secf = ncoeff
      else
        secf = int((ncoeff-1)/delta)
      endif
      ioff = secf * int(delta)

      stime = nowtim( starttime, 0, 0, 0, secf )
      starttime = stime
      write(*,'(a)')'Filtered start: '//starttime


c-------------------------------------------------------------------------------
c     write out info block

      delta = newdel
      if( tunits.ne.'Hz') delta = 1./delta

      window = otswindow 
      form   = outform
      format = outformat
      call ts_wrtinfo( outd )
      if( tunits.ne.'Hz') delta = 1./delta

c-------------------------------------------------------------------------------
c
c Begin the digital filtering convolution
c
c-------------------------------------------------------------------------------

c...set up bounds for misdat (machine precision problems)
      misdatl = misdat*0.99999
      misdatu = misdat*1.00001

      npt  = 0 
      iout = 0

      form   = inform
      format = informat

c...load the ring buffer

      write(*,'(a,i3)')'loading ring buffer with points =', ncoeff-1

      do k = 1, ncoeff-1
         call ts_in1(ind, dt(1,k))
         if( dt(1,k).eq.EOF ) goto 9000
      enddo
      k = ncoeff

c...read next data segment 

      write(*,'(a)')'Filtering ...'
      do while(.TRUE.)

        do j = 1, ifact
          call ts_in1(ind, dt(1,k))
          if( dt(1,k).eq.EOF ) goto 9000
          npt = npt+1
          k = k + 1
          if( k.eq.ncoeff+1 ) k = 1
        enddo


c...perform filter operation

        do i = 1, nchan
          rout(i) = 0.0 
          jj = k
          do j = 1, ncoeff
c...check data ne misdat;     if eq misdat then set rout to misdat
            if(dt(i,jj).gt.misdatl.and.dt(i,jj).lt.misdatu) then
              rout(i) = misdat
            endif

            if( rout(i).ne.misdat ) then
              rout(i) = rout(i) + filt(j)*dt(i,jj)
            endif
            jj = jj + 1
            if(jj.gt.ncoeff) jj = 1
          enddo
          datout(i) = rout(i)
        enddo

c...output filtered data

        if( FORMATTED ) then
           if( outformat.eq.'FREE' ) then
              write(outd,*) (datout(i),i=1,nchan)
           else
              write(outd,outformat) (datout(i),i=1,nchan)
           endif
        else
           write(outd) (datout(i),i=1,nchan)
        endif
        iout = iout+1

      enddo

9000  write(*,*) 'EOF found; npt filtered = ', npt
      write(*,*) 'Number of data output   = ', iout
      nsec = iout/delta
      write(*,*) 'Number of secs output   = ', nsec
      etime = nowtim( starttime, 0, 0, 0, nsec )
      write(*,'(a)')'Data end time  : '//etime

c--Write start and end times into windows file
c
      fout = 'windows.'//proj
  405 open( outd2, file=fout, status='old', form='formatted', err=406 )
      write(*,'(4a)')'Opened old project windows.',proj,' file to ',
     &                  'add window info:'
c...read to end of windows file      
      do while( .TRUE. )
        read( outd2,*,end=407 )
      enddo
      write(*,*)'Should never get this message !!!'
      stop
  406 open( outd2, file=fout, status='new', form='formatted', err=9999 )      
      write(*,'(3a)')'Opened new project windows.',proj,
     &                  ' file to add window info:'

407   write(*,'(a8,1x,i3.3,1x,i1,1x,a19,a1,a19,3x,f9.6,a)')
     &            window, instrument, nchan, stime, '-', etime, delta,
     &            ' resamp: '//tswindow(7:8)
      write(outd2,'(a8,1x,i3.3,1x,i1,1x,a19,a1,a19,3x,f9.6,a)')
     &            window, instrument, nchan, stime, '-', etime, delta,
     &            ' resamp: '//tswindow(7:8)
      close(unit=outd2)
      stop

9999  stop 'Error writing window information to windows file....'
      end
