c
c     WTIME
c
c     derives window time and optionally writes info into file
c     windows.prj where "prj" is the project code
c
c--------------------------------------------------------------------

      program wtime
      
      implicit none
      
c---------------------------------------------------------------------

      include 'ctrlblk.inc' 
      include 'io.inc' 
      include 'version.inc' 
      include 'infoblk.inc'
      include 'defaults.inc'
      include 'op_sys.inc'
      include 'bdate.inc'

      integer lens, ios
      integer nent, prterr
      integer byy, bmm, bdd, bhh, bmn, bss
      integer n

      logical   APPEND, SINGLE

      real data(5)

      character indat*80, wfile*11, proj*3
      character*8  tswindow
      character*19 stime, etime, nowtim
      character*6  progprec
      character*24 date_string
      character*60 path
      character*1  sep
      character*10 cmdarg

      integer lnblnk
      integer iarg, narg, getnarg

      external date
            
c-------------------------------------------------------------------------------
c     initialize

      call getdir(path)

      call fdate(date_string)
      call chkend(sysend)

      call precision( SINGLE )
      if( SINGLE ) then
        progprec = 'SINGLE'
      else
        progprec = 'DOUBLE'
      endif

      call dirsep(sep)

c-------------------------------------------------------------------------------
      
      n = 0

c-------------------------------------------------------------------------------
c     get command-line arguments

      narg = getnarg()
      do iarg = 1, narg
        call getcmdarg( iarg, cmdarg)
        if( index(cmdarg,'h').ne.0 ) then
          write(*,*)'Permitted options:-'
          write(*,*)'                    -1 -2 etc. iprint level'
          stop
        else
          read(cmdarg,'(i2)') iprint
        endif
      enddo

      if(iprint.eq.0) call iin( 'Give print level (-1/0/1/2/3)',iprint)

 
      if( iprint.ge.1 ) then
          write(*,*) 'Program start at: ', date_string
          write(*,*) 'Machine endian  : ', sysend
          write(*,*) 'UNIX setting    : ', UNIX
        endif      
      
c-------------------------------------------------------------------------------
      prterr = iprint

      if( iprint.ge.1 ) then
        write(*,*)' *************** wime *************** '
        write(*,*)'           version =', ver
        write(*,*)'build date =', bdate
        write(*,*)' '
        write(*,*)' This program is to be run in the project directory'
        write(*,*)' i.e one directory above the station subdirectories'
        write(*,*)' '
      endif


c Open input data file 

      form = '?'
      tswindow = 'tbt101ss'
      call ts_open(ind1,tswindow,indat,.true.,.false.)
      call ts_rdinfo(ind1)
      stime = starttime

      proj  = tswindow(1:3)
      read( starttime, '(i4,5(1x,i2)))') byy, bmm, bdd, bhh, bmn, bss
      if( tunits.eq.'Hz' ) then
        continue
      else if( tunits.eq.'s' ) then
        delta = 1./delta
      else
        write(*,*)'Time units not recognised >', tunits
        write(*,*)'only "s" or "Hz" permitted'
        stop
      endif

      if( iprint.ge.2 ) write(*,*)'Reading data...'
c
c Loop over data reading it all 
c
      do while( data(1).ne.EOF )
        n = n+1
        call ts_in1( ind1, data )
        if( iprint.ge.3 ) then
          write(*,*)'n, data =', n, data
        endif
        if( iprint.ge.1 ) then
          if( 25000*(n/25000).eq.n ) then
            write(*,*)'Read in....', n
          endif
        endif
      enddo

      nent = n - 1
      if(iprint.ge.0) write(*,'(a,i10)')'EOF found; nent =',nent

      lens = (nent-1)/delta
      etime = nowtim( stime, 0, 0, 0, lens )

      write(*,*)' '
      write(*,2001) window(1:8), instrument, nchan, stime, etime, delta
      write(*,*)' '
2001  format(a8,1x,i3.3,1x,i1,1x,a19,'-',a19,2x,g16.7)

      APPEND = .true.
      wfile = 'windows.'//proj
      call lin ( 'Append results to '// wfile//' ?',APPEND)
      if(APPEND) THEN
c$$$     --- access='APPEND' is a fortran 77 extension
         open(outd1,file=wfile,access='APPEND',err=9998)
         write(outd1,2001,err=9997)window(1:8), instrument, nchan,
     &        stime, etime, delta
         close (outd1)
      endif

      stop

9997  continue
      write(*,*)'wtime: error',ios,' writing to '//
     &     wfile(1:lnblnk(wfile))
      stop

9998  continue
      write(*,*)'wtime: unable to open '//wfile(1:lnblnk(wfile))
      stop
7000  continue
      write(*,*) 'Error during read...'
      stop
      end
